/**
 *	@file	ChildFrame.cpp
 *	@brief	^uy[WP̏.
 */

#include "stdafx.h"

//#include <vector>
#include "PluginManager.h"
#include "MtlBrowser.h"

#include "FavoriteMenu.h"
#include "DonutFavoritesMenu.h"
#include "DonutView.h"
#include "AddressBar.h"
#include "MDITabCtrl.h"
#include "MDIChildUserMessenger.h"

#include "option/DLControlOption.h"
#include "option/StartUpOption.h"
#include "option/DonutConfirmOption.h"
#include "option/IgnoreURLsOption.h"
#include "option/CloseTitleOption.h"
#include "option/UrlSecurityOption.h"	//+++
#include "ExStyle.h"					//+++

#include "ParseInternetShortcutFile.h"	//+++

#include "FileNotification.h"
#include "DonutPFunc.h" 		//+++
#include "ChildFrame.h"

//#include "MainFrame.h"			//+++ debug



//#include "MDIChildUserMessenger.h"
#ifdef _DEBUG
	const bool _Donut_ChildFrame_traceOn = true;	//false;
	#define dcfTRACE	if (_Donut_ChildFrame_traceOn) ATLTRACE
#else
	#define dcfTRACE
#endif


extern const LPCTSTR	g_lpszLight[];
extern const int		g_LIGHTMAX;



// ===========================================================================
// Ey[Wǂݍ

CChildFrame::CChildFrame(CMDITabCtrl &MDITab, CDonutAddressBar &addressbar, bool bNewWindow2, DWORD dwDefaultDLControlFlags)
	: m_bNavigateBack(FALSE)
	, m_bNavigateForward(FALSE)
	, m_MDITab(MDITab)
	, m_AddressBar(addressbar)
	, m_bNewWindow2(bNewWindow2)
	, m_wndBrowser(this, 7)
	, m_FavMenu(this, ID_INSERTPOINT_CHILDFAVORITEMENU)
	, m_nProgress(-1)
	, m_nProgressMax(0)
	, m_bPageFocusInitialized(false)
	, m_bClosing(false)
	, m_bWaitNavigateLock(true)
	, m_hWndFocus(NULL)
	, m_view(dwDefaultDLControlFlags)
	, m_bOperateDrag(false)
	, m_bExPropLock(false)
	, m_hWndF(NULL)
	, m_hWndA(NULL)
	, m_strBookmark(NULL)
	, m_nPainBookmark(0)
	, m_nSecureLockIcon( secureLockIconUnsecure )
	, m_bPrivacyImpacted( TRUE )
	, m_bInitTravelLog( TRUE )
	, m_nImgWidth( -1 )
	, m_nImgHeight( -1 )
	, m_bNowHilight(FALSE)
	, m_bAutoHilight( false )
  #if 1	//+++
	, m_nCmdType(0)
	, m_bImageAutoSizeReq(0)
	, m_nImgScl(100)
	, m_nImgSclSav(100)
	, m_bImg(0)
	, m_japanCharSet(-1)
  #endif
{
  #if 1	//+++
	{
		static bool bInit				= false;
		static bool bImgAuto_NouseLClk	= false;
		static int  nImgSclSw			= 0;
		if (bInit == 0) {
			CIniFileI pr( g_szIniFileName, _T("ETC") );
			bImgAuto_NouseLClk	= pr.GetValue(_T("ImageAutoSize_NouseLClick")) != 0;
			nImgSclSw			= pr.GetValue(_T("ImageAutoSize_FirstOn")) != 0;
		}
		m_bImgAuto_NouseLClk	= bImgAuto_NouseLClk;
		m_nImgSclSw				= nImgSclSw;
	}
  #endif
}


/** NV^uŊJA
 */
void CChildFrame::OnDocHostUIOpenNewWin(WORD wNotifyCode, WORD /*wID*/, HWND /*hWndCtl*/)
{
	if (wNotifyCode == NM_ON) {
		m_view.m_ViewOption.m_dwExStyle |= DVS_EX_OPENNEWWIN;
		m_MDITab.NavigateLockTab(m_hWnd, true);
	} else if (wNotifyCode == NM_OFF) {
		m_view.m_ViewOption.m_dwExStyle &= ~DVS_EX_OPENNEWWIN;
		m_MDITab.NavigateLockTab(m_hWnd, false);
	} else if (m_view.m_ViewOption.m_dwExStyle & DVS_EX_OPENNEWWIN) {
		m_view.m_ViewOption.m_dwExStyle &= ~DVS_EX_OPENNEWWIN;
		m_MDITab.NavigateLockTab(m_hWnd, false);
	} else {
		m_view.m_ViewOption.m_dwExStyle |= DVS_EX_OPENNEWWIN;
		m_MDITab.NavigateLockTab(m_hWnd, true);
	}
}


void CChildFrame::OnNewWindow2(IDispatch **ppDisp, bool &bCancel)
{
	dcfTRACE( _T("OnNewWindow2\n") );

	if (CMainOption::s_bAppClosing) {
		dcfTRACE( _T(" application closing, ignore this event\n") );
		bCancel = true;
		return;
	}

	m_MDITab.SetLinkState(LINKSTATE_A_ON);
	CChildFrame *pChild = CChildFrame::NewWindow(	m_hWndMDIClient,
													m_MDITab,
													m_AddressBar,
													true,
													_GetInheritedDLControlFlags() );

	//m_MDITab.SetLinkState(LINKSTATE_OFF);
	// Note: In this case, must be activated in BeforeNavigate2 strangely
	// pChild->ActivateFrameForNewWindowDelayed();
	if (pChild == NULL) {
		bCancel = true;
		return;
	}

	//Raise Plugin Event
	//CComBSTR bstr;
	//pChild->m_spBrowser->get_LocationURL(&bstr);
	//CPluginManager::ChainCast_PluginEvent(DEVT_TAB_OPENED,(DWORD)(LPCTSTR)CString(bstr),0);

	pChild->SetWaitBeforeNavigate2Flag();			//+++ ABeforeNavigate2()s܂ł̊ԃAhXo[XVȂ悤ɂtOon

	pChild->m_strSearchWord = m_strSearchWord;

  #if 1 //def USE_UNDONUT_G_SRC		//+++ gaeunDonut_g ̏𔽉fĂ݂ꍇ.
	pChild->m_bNowHilight	= m_bNowHilight;
  #endif

	pChild->m_spBrowser->QueryInterface(IID_IDispatch, (void **) ppDisp);
	ATLASSERT(ppDisp != NULL);
}



CChildFrame *CChildFrame::NewWindow(
		HWND				hWndMDIClient,
		CMDITabCtrl &		tabMDI,
		CDonutAddressBar &	adBar,
		bool				bNewWindow2 /*= false*/,
		DWORD				dwDLFlags	/*= CDLControlOption::s_dwDLControlFlags*/)
{
	int nCount = tabMDI.GetItemCount();
	if ( !CMainOption::IsQualify( nCount ) )
		return NULL;

	if (dwDLFlags == (DWORD)-1)
		dwDLFlags = CDLControlOption::s_dwDLControlFlags;

	//ATLTRY(CChildFrame* pChild = new CChildFrame(tabMDI, adBar, bNewWindow2, dwDLFlags));
	CChildFrame *pChild = new CChildFrame(tabMDI, adBar, bNewWindow2, dwDLFlags);

	//[?
	if (pChild != NULL) {
		pChild->CreateEx(hWndMDIClient);
		//+++ ڂƂ...
		//CDonutSearchBar *pSearch = (CDonutSearchBar *) ::SendMessage(pChild->GetTopLevelParent(), WM_GET_SEARCHBAR, 0, 0);
		CDonutSearchBar *pSearch = CDonutSearchBar::GetInstance();
		if (pSearch) {
			pChild->m_strSearchWord = pSearch->RemoveShortcutWord( pSearch->GetSearchStr() );
		}
	}

	return pChild;
}



LRESULT CChildFrame::OnCreate(LPCREATESTRUCT lpcreatestruct)
{
	dcfTRACE( _T("CChildFrame::OnCreate\n") );
	// Let me initialize itself
	LRESULT 	lRet		   = DefWindowProc();

	//TODO: Replace with a URL of your choice
	CRect		rc			   = rcDefault;
	__CalcDefaultRect(rc);
	m_hWndClient = m_view.Create(m_hWnd, rc, _T("about:blank"), WS_CHILD | WS_VISIBLE /* | WS_CLIPSIBLINGS | WS_CLIPCHILDREN*/, WS_EX_CLIENTEDGE, ID_DONUTVIEW);

	//ReLXgj[JX^}CY邩ǂ
	CIniFileI pr( g_szIniFileName, _T("ETC") );
	DWORD		dwIeMenuNoCstm = pr.GetValue( _T("IeMenuNoCstm"), 0 );
	pr.Close();
	m_view.SetIeMenuNoCstm(dwIeMenuNoCstm);

	//hbOhbv̏ݒ
	_InitDragDropSetting();

	m_view.QueryControl(IID_IWebBrowser2, (void **) &m_spBrowser);

	WebBrowserEvents2Advise();

	if ( _check_flag(MAIN_EX_REGISTER_AS_BROWSER, CMainOption::s_dwMainExtendedStyle) )
		SetRegisterAsBrowser(true); 	// for target name resolution

	_SetupWindowCloseHook();

	// set up for mdi tab ctrl
	CMenuHandle menu0		   = m_MDITab.m_menuPopup.GetSubMenu(0);
	HMENU		hMenu		   = menu0.GetSubMenu(_nPosFavoriteMenuOfTab);
	m_FavMenu.InstallExplorerMenu(hMenu);

	if (!m_bNewWindow2)
		SetVisible(true);

	CFavoritesMenuOption::Add(m_hWnd);

	m_japanCharSet = -1;

	return lRet;
}



void CChildFrame::__CalcDefaultRect(CRect &rc)
{
	BOOL bMaximized = FALSE;
	HWND hWndActive = MDIGetActive(&bMaximized);

	if (hWndActive == NULL || bMaximized) {
		::GetClientRect(m_hWndMDIClient, &rc);
	}
}



void CChildFrame::_SetupWindowCloseHook()
{
	HWND hWndBrowser;

	::EnumChildWindows(m_view.m_hWnd, (WNDENUMPROC) _EnumProc, (LPARAM) &hWndBrowser);
	ATLASSERT( ::IsWindow(hWndBrowser) );
	m_wndBrowser.SubclassWindow(hWndBrowser);
}



//static
BOOL CALLBACK CChildFrame::_EnumProc(HWND hWnd, LPARAM lParam)
{
	HWND *phWnd = (HWND *) lParam;
	ATLASSERT( phWnd != 0 );
	*phWnd = hWnd;
	return FALSE;
}



void CChildFrame::_InitDragDropSetting()
{
	CIniFileI	pr( _GetFilePath("MouseEdit.ini"), _T("MouseCtrl") );
	DWORD			dwCommand = pr.GetValue(_T("DragDrop"), 0);
	m_bOperateDrag = (dwCommand != 0);
	pr.Close();
	if (m_bOperateDrag) {
		m_view.SetOperateDragDrop(TRUE, dwCommand);
	}
}



//public:
void CChildFrame::OnBeforeNavigate2(
					IDispatch *			pDisp,
					const CString &		strURL,
					DWORD				nFlags,
					const CString &		strTargetFrameName,
					CSimpleArray<BYTE>&	baPostedData,
					const CString &		strHeaders,
					bool &				bCancel )
{
	dcfTRACE(_T("CChildFrame::BeforeNavigate2 url(%s) frame(%s)\n"), strURL.Left(100), strTargetFrameName);

	{
		//vOCCxg - irQ[gO
		DEVTS_TAB_NAVIGATE stn;
		stn.nIndex			 = m_MDITab.GetTabIndex(m_hWnd);
		stn.lpstrURL		 = (LPCTSTR) strURL;
		stn.lpstrTargetFrame = (LPCTSTR) strTargetFrameName;
		int 	nRet		 = CPluginManager::ChainCast_PluginEvent(DEVT_TAB_BEFORENAVIGATE, stn.nIndex, (SPARAM) &stn);

		if (nRet == -1) {
			//irQ[gLZ
			bCancel = true;
			return;
		} else if (nRet == -2) {
			//N[Y
			bCancel 	  = true;
			m_bNewWindow2 = false;
			m_bClosing	  = true;
			PostMessage(WM_CLOSE);		// It's possible to post twice, but don't care.
			return;
		}
	}

	if (m_view.m_ViewOption.m_dwExStyle & DVS_EX_BLOCK_MAILTO) {
		CString strMailto = strURL.Left(6);
		strMailto.MakeUpper();

		if (strMailto.Compare( _T("MAILTO") ) == 0) {
			bCancel = true;
			return;
		}
	}

	if (m_bClosing) {
		bCancel = true;
		return;
	}

	// deter popups
	if ( m_bNewWindow2 && IsPageIWebBrowser(pDisp) && CIgnoredURLsOption::SearchString(strURL) ) {	// close ignored url
		bCancel 	  = true;
		m_bNewWindow2 = false;
		m_bClosing	  = true;
		PostMessage(WM_CLOSE);			// It's possible to post twice, but don't care.

		{
			//vOCCxg - |bvAbv}~
			CPluginManager::BroadCast_PluginEvent(DEVT_BLOCKPOPUP, (FPARAM) (LPCTSTR) strURL, 0);
		}
		return;
	}

	// javascriptn܂NewWindowclose
	if (m_bNewWindow2) {
		CString strJava = strURL.Left(10);
		strJava.MakeUpper();

		if (strJava.Find(_T("JAVASCRIPT")) != -1) {
			bCancel 	  = true;
			m_bNewWindow2 = false;
			m_bClosing	  = true;
			PostMessage(WM_CLOSE);		// It's possible to post twice, but don't care.

			DonutOpenFile(m_hWnd, strURL);
			return;
		}
	}

  #if 1	//+++ UrlʊgvpeBݒ̏
	DWORD exopts = 0xFFFFFFFF, dlCtlFlg = 0xFFFFFFFF, exstyle = 0xFFFFFFFF, autoRefresh = 0xFFFFFFFF;
	if (CUrlSecurityOption::FindUrl( strURL, &exopts )) {
		CExProperty  ExProp(CDLControlOption::s_dwDLControlFlags, CDLControlOption::s_dwExtendedStyleFlags, 0, exopts);
		dlCtlFlg	= ExProp.GetDLControlFlags();
		exstyle		= ExProp.GetExtendedStyleFlags();
		autoRefresh = ExProp.GetAutoRefreshFlag();
	}
  #endif

	// Navigate lock
	if ( !m_bExPropLock
	   && _check_flag(DVS_EX_OPENNEWWIN, m_view.m_ViewOption.m_dwExStyle)
	   && m_bWaitNavigateLock == false
	   && !IsRefreshBeforeNavigate2(pDisp) )
	{
		m_bExPropLock = FALSE;
		dcfTRACE( _T(" Locked, open new window\n") );
		if (dlCtlFlg == 0xFFFFFFFF)
			dlCtlFlg =  _GetInheritedDLControlFlags();
		CChildFrame *pChild = CChildFrame::NewWindow( m_hWndMDIClient, m_MDITab, m_AddressBar, false, dlCtlFlg );
		if (pChild) {
			pChild->SetWaitBeforeNavigate2Flag();	//*+++ ABeforeNavigate2()s܂ł̊ԃAhXo[XVȂ悤ɂtOon
			pChild->ActivateFrameForNewWindowDelayed();
			pChild->Navigate2(strURL);
			pChild->m_strSearchWord = m_strSearchWord;
		  #if 1 //def USE_UNDONUT_G_SRC		//+++ gaeunDonut_g ̏𔽉fĂ݂ꍇ.
			pChild->m_bNowHilight	= m_bNowHilight;
		  #endif
			pChild->ForceMessageLoop(); 	//*+++

		  #if 1	//+++ urlʊgvpeB̏.
			if (exopts != 0xFFFFFFFF) {
				pChild->view().PutDLControlFlags( dlCtlFlg );
				pChild->SetViewExStyle( exstyle );
				pChild->view().m_ViewOption.SetAutoRefreshStyle( autoRefresh );
			}
		  #endif
		}
		bCancel 	  = true;
		return;
	}

  #if 1	//+++ urlʊgvpeB̏.... ߂Eiނł̊gvpeB̕łƂ̕ۑłĂȂ̂ŁAj]̂ŁA߂Ă...
	if (CUrlSecurityOption::s_bValid) {
		if (exopts != 0xFFFFFFFF && CUrlSecurityOption::activePageToo()) {
			this->view().PutDLControlFlags( dlCtlFlg );
			this->SetViewExStyle( exstyle );
			this->view().m_ViewOption.SetAutoRefreshStyle( autoRefresh );
		//} else {
		}
	}
  #endif

	m_bExPropLock	= FALSE;

	// Note: Some ActivateFrame would go mad, because MDI client window not setup yet.
	if (m_bNewWindow2) {				// delayed activation if OnNewWindow2 called
		ActivateFrameForNewWindowDelayed();
		m_bNewWindow2 = false;
	}

	// UH
	// nCCgH
  #if 1 //def USE_UNDONUT_G_SRC		//+++ gaeunDonut_g ̏𔽉fĂ݂ꍇ.
	//m_bNowHilight=FALSE;	// gae: xKpnCCg͖Iɉ܂ňێ
  #else
	m_bNowHilight	= FALSE;
  #endif
	m_nPainBookmark = 0;
	m_strBookmark	= NULL;

	{
		//Cxg - irQ[g
		DEVTS_TAB_NAVIGATE stn;
		stn.nIndex			 = m_MDITab.GetTabIndex(m_hWnd);
		stn.lpstrURL		 = (LPCTSTR) strURL;
		stn.lpstrTargetFrame = (LPCTSTR) strTargetFrameName;
		CPluginManager::BroadCast_PluginEvent(DEVT_TAB_NAVIGATE, stn.nIndex, (SPARAM) &stn);
	}
}



DWORD CChildFrame::_GetInheritedDLControlFlags()
{
	DWORD dwDLFlags;

	if (this &&  _check_flag(MAIN_EX_INHERIT_OPTIONS, CMainOption::s_dwMainExtendedStyle) )
		dwDLFlags = m_view._GetDLControlFlags();
	else
		dwDLFlags = CDLControlOption::s_dwDLControlFlags;

	// default
	return dwDLFlags;
}



int CChildFrame::ActivateFrameForNewWindowDelayed(int nCmdShow /*= -1*/)
{
	dcfTRACE( _T("CChildFrame::ActivateFrameForNewWindowDelayed - now activating!\n") );

	HWND	hWndActive = MDIGetActive();
	if (hWndActive != NULL && CMainOption::s_dwMainExtendedStyle & MAIN_EX_NOACTIVATE_NEWWIN)
		nCmdShow = SW_SHOWNOACTIVATE;

	return ActivateFrame(nCmdShow);
}



int CChildFrame::ActivateFrame(int nCmdShow /*= -1*/)
{
	ATLASSERT( ::IsWindow(m_hWnd) );
	if (m_MDITab.GetTabIndex(m_hWnd) == -1) 	//Ȃ񂾂MDITabMDIActivate̕ɌĂяoĂ܂̂
		m_MDITab.OnMDIChildCreate(m_hWnd);		//낢ƏԂĂ

	if ( _check_flag(m_view.m_ViewOption.m_dwExStyle, DVS_EX_OPENNEWWIN)) {
		m_MDITab.NavigateLockTab(m_hWnd, true);
	}

	//Raise Plugin Event
	int nNewIndex = m_MDITab.GetTabIndex(m_hWnd);
	CPluginManager::ChainCast_PluginEvent(DEVT_TAB_OPENED, nNewIndex, 0);

	return baseClass::ActivateFrame(nCmdShow);
}


void CChildFrame::OnDocumentComplete(IDispatch *pDisp, const CString &strURL)
{
	if ( IsPageIWebBrowser(pDisp) ) {	// it means a page complete downloading
		dcfTRACE( _T("CChildFrame::OnDocumentComplete\n") );
		m_bWaitNavigateLock = false;	// you are allowed!
		m_bExPropLock		= FALSE;

		if ( MDIGetActive() == m_hWnd && DonutBrowserCanSetFocus(m_hWnd) ) {
			_SetPageFocus();
		}
	}

	//pX^CV[gݒ肷
	ApplyDefaultStyleSheet();

	//߂Eiނ̗[h
	SetTravelLogData();

	//摜t@CȂIE̐ݒɂăTCY
	CheckImageAutoSize(&strURL, TRUE);
	//SetBodyStyleZoom(0, TRUE);	//+++

	//I[gnCCg
	if (m_bAutoHilight)
		CDonutSearchBar::GetInstance()->ForceSetHilightBtnOn(true);

	bool bHilight = m_bAutoHilight || CDonutSearchBar::GetInstance()->GetHilightSw();
	//if (bHilight && !m_bNowHilight)
	if (bHilight)
	{
	  #if 1 //def USE_UNDONUT_G_SRC		//+++ gaeunDonut_g ̏𔽉fĂ݂ꍇ.
		if (!m_strSearchWord.IsEmpty())
			OnHilightOnce(pDisp, m_strSearchWord);
	  #else
		if (!m_strSearchWord.IsEmpty())
			OnHilight(m_strSearchWord);
	  #endif
	}

	//::PostMessage(GetTopLevelParent(), WM_COMMAND, (WPARAM)ID_SEARCHBAR_HILIGHT, 0);

	{
		//vOCCxg - [h
		//if(IsPageIWebBrowser(pDisp)){
		CComQIPtr<IWebBrowser2> 	pWB2 = pDisp;

		if (pWB2) {
			DEVTS_TAB_DOCUMENTCOMPLETE	dc;
			dc.lpstrURL   = (LPCTSTR) strURL;

			CComBSTR	bstrTitle;
			pWB2->get_LocationName(&bstrTitle);

			CString 	strTitle = bstrTitle;
			dc.lpstrTitle = (LPCTSTR) strTitle;
			dc.nIndex	  = m_MDITab.GetTabIndex(m_hWnd);
			dc.bMainDoc   = IsPageIWebBrowser(pDisp);
			CPluginManager::BroadCast_PluginEvent(DEVT_TAB_DOCUMENTCOMPLETE, dc.nIndex, (DWORD_PTR) &dc);
		}
		//}
	}
}



void CChildFrame::OnDownloadComplete()
{
	dcfTRACE( _T("CChildFrame::OnDownloadComplete\n") );
}



void CChildFrame::OnStatusTextChange(const CString &strText)
{
	{
		//vOCCxg - Xe[^XeLXgύX
		int nRet = CPluginManager::ChainCast_PluginEvent(DEVT_CHANGESTATUSTEXT, (FPARAM) (LPCTSTR) strText, 0);
		if (nRet < 0)
			return;
	}

	BOOL bFilter = FALSE;
	if (m_view.m_ViewOption.m_dwExStyle & DVS_EX_MESSAGE_FILTER) {
		if (strText.Find(_T("http"  )) != -1)						bFilter = TRUE;
		if (strText.Find(_T("ftp"	)) != -1)						bFilter = TRUE;
		if (strText.Find(_T("ڑ"  )) != -1)						bFilter = TRUE;
		if (strText.Find(_T("mailto")) != -1)						bFilter = TRUE;
		if (strText.Find(_T("file"  )) != -1)						bFilter = TRUE;
		if (strText.Find(_T("java"  )) != -1)						bFilter = TRUE;
		if ( strText.IsEmpty()	 )									bFilter = TRUE;
		if (strText.Compare(_T("y[W\܂")) == 0) 	bFilter = TRUE; 	//minit
		if (bFilter == FALSE)										return;
	}

	m_strStatusBar = strText;

	if (MDIGetActive() == m_hWnd) {
		CWindow wndFrame   = GetTopLevelParent();
		HWND	hWndStatus = wndFrame.GetDlgItem(ATL_IDW_STATUS_BAR);
		int 	nMode	   = (int) ::SendMessage(hWndStatus, WM_GET_OWNERDRAWMODE, 0, 0);
		if (nMode)
			MtlSetStatusText(hWndStatus, strText);
		else
			MtlSetWindowText(hWndStatus, strText);

		// UDT DGSTR ( update
		LPCTSTR lpszText   = strText;
		SendMessage(GetTopLevelParent(), WM_UPDATE_TITLEBAR, (WPARAM) lpszText, (LPARAM) 0);
		// ENDE
	}
}



void CChildFrame::OnTitleChange(const CString &strTitle)
{
	CString strURL = GetLocationURL();

	if ( CCloseTitlesOption::SearchString(strTitle) ) {
		m_bClosing = true;
		PostMessage(WM_CLOSE);
		{
			//vOCCxg - ^Cg}~
			CPluginManager::BroadCast_PluginEvent(DEVT_BLOCKTITLE, (FPARAM) (LPCTSTR) strTitle, 0);
		}
		return;
	}

	dcfTRACE( _T("OnTitleChange : %s\n"), strTitle.Left(100) );
	// change title
	SetWindowText( MtlCompactString(strTitle, 255) );

  #if 0 //+++ ɁAy[WJabout:blankݒLZ... +mod.1.17ȑO̕s΍ŁAǂȍ~ł͋Aĕsɉꍇ肻ȂŁA~.
	// change address bar
	if (MDIGetActive() == m_hWnd) {
		if ((strURL == "about:blank" || strURL.IsEmpty()) && IsWaitBeforeNavigate2Flag()) { //+++
			;
		} else {	//+++ ʏ.
			m_AddressBar.SetWindowText(strURL);
		}
	}
  #else
	// change address bar
	if (MDIGetActive() == m_hWnd)
		m_AddressBar.SetWindowText(strURL);
  #endif
}


void CChildFrame::OnCommandStateChange(long Command, bool bEnable)
{
	if (Command == CSC_NAVIGATEBACK) {
		m_bNavigateBack 	= bEnable /*? TRUE : FALSE*/;
	} else if (Command == CSC_NAVIGATEFORWARD) {
		m_bNavigateForward	= bEnable /*? TRUE : FALSE*/;
	} else if (Command == CSC_UPDATECOMMANDS) {
	}
}


void CChildFrame::OnStateConnecting()
{
	m_MDITab.SetConnecting(m_hWnd);
	m_bPrivacyImpacted = TRUE;	// y[Wǂݍ݌OnStateConnectingĂ΂y[Ŵ
								// NbL[ACR\Ȃy[W
	//m_nSecureLockIcon = secureLockIconUnsecure;
}


//void CChildFrame::OnStateDownloading()
//{
//	m_MDITab.SetDownloading(m_hWnd);
//}


void CChildFrame::OnStateCompleted()
{
	m_MDITab.SetComplete(m_hWnd);

	HWND hWndA2 = ::GetActiveWindow();
	HWND hWndF2 = ::GetFocus();

	if (m_hWndA)
		::SetActiveWindow(m_hWndA);

	if (m_hWndF)
		::SetFocus(m_hWndF);
}



#if 1 //+++ IɁȀŃbZ[W΂...sv...
int CChildFrame::ForceMessageLoop()
{
	HWND	hWnd	= m_hWnd;
	HWND	hWndA = ::GetActiveWindow();
	if (hWnd != hWnd)
		return 1;
	int 	ret;
	MSG 	msg 	= {0};
	int 	n		= 0;
	while ((ret = ::PeekMessage(&msg, hWnd, 0, 0, PM_NOREMOVE)) != 0) {
		if (!GetMessage (&msg,hWnd,0,0))	/* bZ[W. QUITAU*/
			return 0;	//x return msg.wParam ;
		if (OnForwardMsg(&msg, 0) == 0)
		{
			::TranslateMessage(&msg);
			::DispatchMessage(&msg);
		}
		++n;
	}
	return 1;
}
#endif



// ===========================================================================
// I

/** +++:ȊÕ^u
 */
LRESULT CChildFrame::OnWindowCloseExcept(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
{
	if ( !CDonutConfirmOption::OnCloseAllExcept( GetTopLevelParent() ) )
		return 0;

	CWaitCursor 		 cur;
	CLockRedrawMDIClient lock(m_hWndMDIClient);
	CLockRedraw 		 lock2(m_MDITab);
	MtlCloseAllMDIChildrenExcept(m_hWndMDIClient, m_hWnd);
	return 0;
}



/** +++:^ủE/ׂĕ
 */
LRESULT CChildFrame::OnLeftRightClose(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
{
	bool	bLeft	= (wID == ID_LEFT_CLOSE);

	if ( !CDonutConfirmOption::OnCloseLeftRight( GetTopLevelParent(), bLeft ) )
		return 0;

	CWaitCursor cur;

	HWND		hWndActive = (HWND) ::SendMessage(m_hWndMDIClient, WM_MDIGETACTIVE, 0, (LPARAM) NULL);
	int 		nCurSel    = m_MDITab.GetTabIndex(m_hWnd);
	int 		nCurSel2   = m_MDITab.GetTabIndex(hWndActive);
	int 		nCurSel3   = m_MDITab.GetTabIndex(m_hWndMDIClient);

	if (nCurSel == -1)
		return 0;

	::SendMessage(GetTopLevelParent(), WM_USER_WINDOWS_CLOSE_CMP, (WPARAM) nCurSel, (LPARAM) bLeft);
	return 0;
}


/** SẴ^u
 */
void CChildFrame::OnWindowCloseAll(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
{
	::SendMessage(::GetParent( ::GetParent(m_hWnd) ), WM_COMMAND, ID_WINDOW_CLOSE_ALL, 0);
}




///+++:uEU
void CChildFrame::OnBrowserClose()
{
	dcfTRACE( _T("CChildFrame::OnBrowserClose\n") );
	SetMsgHandled(FALSE);
	m_bClosing = true;
	PostMessage(WM_CLOSE);
}


/** +++:t@C̕.
 */
void CChildFrame::OnFileClose(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
{
  #if 1 //+++ ^ubN΍... OnClosêőv̂悤ǁAƂ肠.
	if ( s_bMainframeClose == 0 												//+++ unDonutIȊO
		&& _check_flag(m_view.m_ViewOption.m_dwExStyle, DVS_EX_OPENNEWWIN)		//+++ irQ[gbÑy[W
		&& (CMainOption::s_dwMainExtendedStyle2 & MAIN_EX2_NOCLOSE_NAVILOCK)	//+++ irQ[gbÑy[WȂA̎w肪
	){
		m_bClosing = false;
		return; 																//+++ ɋA
	}
  #endif
	m_bClosing = true;
	PostMessage(WM_CLOSE);
}



//======================

/** +++:
 */
void CChildFrame::OnClose()
{
  #if 1 //+++ ^ubN΍...
	if ( s_bMainframeClose == 0 												//+++ unDonutIȊO
		&& _check_flag(m_view.m_ViewOption.m_dwExStyle, DVS_EX_OPENNEWWIN)		//+++ irQ[gbÑy[W
		&& (CMainOption::s_dwMainExtendedStyle2 & MAIN_EX2_NOCLOSE_NAVILOCK)	//+++ irQ[gbÑy[WȂA̎w肪
	){
		m_bClosing = false;
		return; 																//+++ ɋA
	}
  #endif

	SetMsgHandled(FALSE);
	m_bClosing = true;

	int  nIndex 		= m_MDITab.GetTabIndex(m_hWnd);

	// for mdi tab ctrl
	HWND hWndActiveNext = NULL;

	if (MDIGetActive() == m_hWnd) {
		int nIndex = m_MDITab.ManageClose(m_hWnd);

		if (nIndex != -1) {
			hWndActiveNext = m_MDITab.GetTabHwnd(nIndex);
			ATLASSERT( ::IsWindow(hWndActiveNext) );
		}
	}

	m_MDITab.OnMDIChildDestroy(m_hWnd);

	if (hWndActiveNext)
		MDIActivate(hWndActiveNext);

	if ( !CMainOption::s_bAppClosing ||  !(CStartUpOption::s_dwFlags == CStartUpOption::STARTUP_LATEST) ) { 	//minit
		CString strURL	 = GetLocationURL();
		if ( !strURL.IsEmpty() ) {	//+++ Ƀ`FbN.
			CString strTitle = GetLocationName();
			SDfgSaveInfo::List	arrFore;
			SDfgSaveInfo::List	arrBack;

			if (CMainOption::s_bTravelLogClose) {
				m_view.m_ViewOption._OutPut_TravelLogs(arrFore, arrBack);
			}
			if (CMainOption::s_pMru)	//+++
				CMainOption::s_pMru->AddToList(strURL, &arrFore, &arrBack, strTitle);
		}
	}

	{
		//vOCCxg - N[Y
		CPluginManager::BroadCast_PluginEvent(DEVT_TAB_CLOSE, nIndex, 0);
	}
}


/** IJ
 */
void CChildFrame::OnDestroy()
{
	dcfTRACE( _T("CChildFrame::OnDestroy\n") );
	SetMsgHandled(FALSE);
	m_bClosing							  = true;

	if (m_bOperateDrag)
		m_view.SetOperateDragDrop(FALSE, 0);

	SetRegisterAsBrowser(false);

	// m_view.DestroyWindow makes offline state reset, so
	// save global offline state
	bool bGlobalOffline = MtlIsGlobalOffline();

	// Before AtlAdviseSinkMap(this, false) destroy view,
	// cuz I wanna handle OnNewWindow2 event
	// And while destroying view, a meaningless WM_DRAWCLIPBOARD may be sent, so ignore it.

	CMainOption::s_bIgnoreUpdateClipboard = true;
	dcfTRACE( _T(" m_view.Destroy\n") );

	if ( m_view.IsWindow() )
		m_view.DestroyWindow();

	CMainOption::s_bIgnoreUpdateClipboard = false;

	dcfTRACE( _T(" DispEventUnadvise\n") );

	WebBrowserEvents2Unadvise();

	// restore global offline state
	MtlSetGlobalOffline(bGlobalOffline);
}



CChildFrame::~CChildFrame()
{
	dcfTRACE( _T("CChildFrame::~CChildFrame\n") );

	if ( m_wndBrowser.IsWindow() )				// scary
		m_wndBrowser.UnsubclassWindow();

	ATLASSERT(m_hMenu == NULL); 				// no menu
}



// ===========================================================================
// {Iȏ


int CChildFrame::_GetShowCmd()
{
	CWindowPlacement	wndpl;
	if ( m_hWnd && ::GetWindowPlacement(m_hWnd, &wndpl) ) {
		return wndpl.showCmd;
	}
	return -1;
}



#if 1
///+++  ۂOnPaint͂ǂقōsĂ邾낤ŁAł
///+++  OnPaint̃^C~Oŉ摜TCY̏ŝ. (OnPaintȂ悤MsgHandled=0ɂĕԂ)
void CChildFrame::OnPaint(HDC hDc)
{
	if (m_bImageAutoSizeReq) {
		CheckImageAutoSize(NULL, FALSE);
		m_bImageAutoSizeReq = false;
	}
	SetMsgHandled(FALSE);
}
#endif

#if 0	//+++	s
void CChildFrame::OnLButtonDown(WORD wparam, const WTL::CPoint& pt)
{
	CRect	rect;
	GetClientRect(&rect);
	if (rect.PtInRect(pt)) {
		MtlSendCommand(m_hWnd, ID_HTMLZOOM_100TOGLE);
	}
}
#endif

//+++
LRESULT CChildFrame::OnSize(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL &bHandled)
{
	BOOL	bMaxActive = FALSE;
	HWND	hWndActive = MDIGetActive(&bMaxActive);

	if (bMaxActive == FALSE)
		bMaxActive = ::IsZoomed(hWndActive) != 0;

	int 	nCmdType   = m_nCmdType;
	m_nCmdType = 0;

  #if 1		//+++ ʂ̃^C~OŃTCY郊NGXg
	m_bImageAutoSizeReq = true;
  #else		//+++ ̃^C~OōXV͕̂s݂.
	CheckImageAutoSize(NULL, FALSE);
  #endif

	dcfTRACE(_T("CChildFrame::OnSize type(%d)\n"), wParam);

	if ( CMainOption::s_bTabMode && (wParam == SIZE_RESTORED || wParam == SIZE_MINIMIZED) ) {
		dcfTRACE( _T(" restored\n") );
		bHandled = TRUE;			// eat it!!
		return 0;
	} else if ( bMaxActive
				&& (   (nCmdType != SC_RESTORE && nCmdType != SC_MINIMIZE)
					&& (wParam == SIZE_RESTORED || wParam == SIZE_MINIMIZED) ) )
	{
		dcfTRACE( _T(" restored\n") );
		bHandled = TRUE;			// eat it!!
		return 0;
	} else {
		bHandled = FALSE;
		return -1;
	}
}


void CChildFrame::OnSysCommand(UINT uCmdType, CPoint pt)
{
  #if 1	//+++ CTRL(+SHIFT)+TABł̃^uړ̏Ԃڒʂɂ鏈
	if ((m_MDITab.GetMDITabExtendedStyle() & MTB_EX_CTRLTAB_MDI) == 0) {	//+++ MDIɂ̂łȂ
		if (uCmdType == SC_PREVWINDOW) {
			m_MDITab.LeftTab();
			SetMsgHandled(TRUE);
			return;
		} else if (uCmdType == SC_NEXTWINDOW) {
			m_MDITab.RightTab();
			SetMsgHandled(TRUE);
			return;
		}
	}
  #endif

	m_nCmdType = uCmdType;

	if ( CMainOption::s_bTabMode && (uCmdType == SC_MINIMIZE || uCmdType == SC_RESTORE) )
		SetMsgHandled(TRUE);
	else
		SetMsgHandled(FALSE);
}



LRESULT CChildFrame::OnForwardMsg(LPMSG pMsg, DWORD)
{
  #if 1	//+++	摜\̂ƂAŃNbNAg嗦؂ւ
	if (m_bImg && m_bImgAuto_NouseLClk == 0 && pMsg->message == WM_LBUTTONDOWN /*&& pMsg->hwnd == m_hWnd*/) {
		CPoint pt;
		::GetCursorPos(&pt);
		CRect	rect;
		//CRect	rectB;
		::GetClientRect(pMsg->hwnd, &rect);
		//CClientDC dc(pMsg->hwnd);
		//::GetBoundsRect(dc, &rectB, 0/*DCB_RESET*/);
		ClientToScreen(&rect);
		rect.right -= GetSystemMetrics(SM_CXVSCROLL);
		rect.bottom-= GetSystemMetrics(SM_CYHSCROLL);
		if (rect.PtInRect(pt)) {
			MtlSendCommand(m_hWnd, ID_HTMLZOOM_100TOGLE);
		}
	}
  #endif

  #if 1	//+++	F5Ń[hƂɁAZOOM߂ꂿႤ̂邽߂ɁA蒲
	if ( baseClass::PreTranslateMessage(pMsg) )
		return TRUE;
	LRESULT lr = m_view.PreTranslateMessage(pMsg);

	if (pMsg->message == WM_KEYDOWN && pMsg->wParam == VK_F5 && m_nImgScl != 100) {
		m_bImageAutoSizeReq = true;
		//SendMessage(WM_PAINT);
		SetTimer(1, 20, OncePaintReq);
	}

	return lr;
  #else
	if ( baseClass::PreTranslateMessage(pMsg) )
		return TRUE;

	return m_view.PreTranslateMessage(pMsg);
  #endif
}


//+++ ^C}[Ŗ܂āAʂTCYŕ`
void CALLBACK CChildFrame::OncePaintReq(HWND hWnd, UINT wparam, UINT_PTR lparam, DWORD )
{
	//m_bImageAutoSizeReq = true;
	::SendMessage(hWnd, WM_PAINT, wparam, lparam);
	::KillTimer(hWnd, 1);
}



// It will be a template method.
void CChildFrame::OnMDIActivate(HWND hwndChildDeact, HWND hwndChildAct)
{
	dcfTRACE( _T("CChildFrame::OnMDIActivate\n") );
	SetMsgHandled(FALSE);

	if (hwndChildAct == m_hWnd) {		// I'm activated
	  #if 0 //+++ ɁAy[WJabout:blankݒLZ... +mod.1.17ȑO̕s΍ŁAǂȍ~ł͋Aĕsɉꍇ肻ȂŁA~.
		CString strURL = GetLocationURL();
		if ((strURL == "about:blank" || strURL.IsEmpty()) && IsWaitBeforeNavigate2Flag()) { //+++
			;
		} else {	//+++ ʏ.
			m_AddressBar.SetWindowText(strURL);
		}
	  #else
		m_AddressBar.SetWindowText( GetLocationURL() );
	  #endif
		_SetPageFocus();
		_RestoreFocus();
		return;
	}

	if (hwndChildDeact == m_hWnd) { 	// I'm deactivated
		_SaveFocus();
	}

	{
		//vOCCxg - ANeBu^uύX
		int nIndexDeact = m_MDITab.GetTabIndex(hwndChildDeact);
		int nIndexAct	= m_MDITab.GetTabIndex(hwndChildAct);
		CPluginManager::BroadCast_PluginEvent(DEVT_TAB_CHANGEACTIVE, nIndexDeact, nIndexAct);
	}
}



///+++ :ID_VIEW_SETFOCUS:"݂̃y[W̃tH[JX܂BtH[JX̃Zbg"
void CChildFrame::OnViewSetFocus(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
{
	// NOTE. _SetPageFoucs would fail if document not completed.
	m_bPageFocusInitialized = false;			// reset focus
	_SetPageFocus();
}



void CChildFrame::_SetPageFocus()
{
	dcfTRACE( _T("CChildFrame::_SetPageFocus(src:%d)\n"), ::GetFocus() );

	if (m_bPageFocusInitialized)
		return;

	if ( !MtlIsApplicationActive(m_hWnd) )
		return;

	if ( IsBrowserNull() )
		return;

	CComPtr<IDispatch>		  spDisp;
	HRESULT 				  hr	= m_spBrowser->get_Document(&spDisp);
	if ( FAILED(hr) )
		return;

	CComQIPtr<IHTMLDocument2> spDoc = spDisp;
	if (!spDoc) 								// document not initialized yet
		return;

	CComPtr<IHTMLWindow2>	  spWnd;
	hr						= spDoc->get_parentWindow(&spWnd);
	if (!spWnd)
		return;

	m_bPageFocusInitialized = true; 			// avoid the endless loop
	hr						= spWnd->focus();	// makes mainframe active
}



void CChildFrame::_RestoreFocus()
{
	if (m_hWndFocus && IsChild(m_hWndFocus) && ::GetFocus() != m_hWndFocus)
	{
		::SetFocus(m_hWndFocus);
	}
}



int	CChildFrame::GetJapanCharSet()
{
	if (m_japanCharSet < 0) {
		// ANeBuEBhE̎擾
		HWND	hWndActive = MDIGetActive();
		if (hWndActive == NULL)
			return 0;

		if (!m_spBrowser)
			return 0;

		// hLg̎擾
		CComPtr<IDispatch>	spDisp;
		HRESULT 			hr	= m_spBrowser->get_Document(&spDisp);
		if ( FAILED(hr) )
			return 0;

		// html̎擾
		CComQIPtr<IHTMLDocument2>	spDocument = spDisp;
		if (!spDocument)
			return 0;

		CComBSTR		bstr;
		spDocument->get_charset(&bstr);

		WTL::CString	str1((LPCWSTR)bstr);

		str1.MakeLower();
		if (str1.Find(_T("utf8")) >= 0 || str1.Find(_T("utf-8")) >= 0) {
			m_japanCharSet = 3;
		} else if (str1.Find(_T("euc")) >= 0) {
			m_japanCharSet = 2;
		} else if (str1.Find(_T("sjis")) >= 0 || str1.Find(_T("shift")) >= 0 || str1.Find(_T("s-jis")) >= 0 || str1.Find(_T("x-jis")) >= 0 || str1.Find(_T("xjis")) >= 0 ) {
			m_japanCharSet = 1;
		}
	}
	if (m_japanCharSet < 0)
		return 0;
	return m_japanCharSet;
}



// ===========================================================================
// ʊ֌W


#if 1	//+++ urlʊgvpeB̏.
void CChildFrame::SetUrlSecurityExStyle(LPCTSTR lpszFile)
{
	DWORD opts = 0;
	if (CUrlSecurityOption::FindUrl( lpszFile, &opts )) {
		CExProperty  ExProp(CDLControlOption::s_dwDLControlFlags, CDLControlOption::s_dwExtendedStyleFlags, 0, opts);
		this->view().PutDLControlFlags( ExProp.GetDLControlFlags() );
		this->SetViewExStyle(ExProp.GetExtendedStyleFlags(), TRUE);
		this->view().m_ViewOption.SetAutoRefreshStyle( ExProp.GetAutoRefreshFlag() );
	}
}
#endif



		/**+++:ID_VIEW_REFRESH:"݂̃y[W̃RecŐV̏ɍXV܂B"
 */
void CChildFrame::OnViewRefresh(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
{
	if (MDIGetActive() == m_hWnd) {
		m_hWndA = NULL;
		m_hWndF = NULL;
	} else {
		m_hWndA = ::GetActiveWindow();
		m_hWndF = ::GetFocus();
	}

	if (::GetAsyncKeyState(VK_CONTROL) < 0) 	// Inspired by DOGSTORE, Thanks
		Refresh2(REFRESH_COMPLETELY);
	else
		Refresh();
}



/**+++:ID_VIEW_STOP:"݂̃y[W̓ǂݍ݂𒆎~܂B"
 */
void CChildFrame::OnViewStop(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
{
	Stop();

	// make sure
	m_nDownloadCounter = 0;
	OnStateCompleted();
}



/**+++:ID_FAVORITE_ADD:"݂̃y[WCɓ̈ꗗɒǉ܂B"
 */
void CChildFrame::OnFavoriteAdd(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
{
	bool bOldShell = _check_flag(MAIN_EX_ADDFAVORITEOLDSHELL, CMainOption::s_dwMainExtendedStyle);

	MtlAddFavorite(GetLocationURL(), MtlGetWindowText(m_hWnd), bOldShell, DonutGetFavoritesFolder(), m_hWnd);

	::SendMessage(GetTopLevelParent(), WM_REFRESH_EXPBAR, 0, 0);
}


/**+++:ID_FAVORITE_GROUP_ADD:"̃y[WCɓO[vɒǉ܂B"
 */
void CChildFrame::OnFavoriteGroupAdd(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
{
	TCHAR		szOldPath[MAX_PATH];			// save current directory

	::GetCurrentDirectory(MAX_PATH, szOldPath);

	const TCHAR szFilter[] = _T("Donut Favorite Groupt@C(*.dfg)\0*.dfg\0\0");

	::SetCurrentDirectory( DonutGetFavoriteGroupFolder() );

	CFileDialog fileDlg(FALSE, _T("dfg"), NULL, OFN_HIDEREADONLY, szFilter);
	fileDlg.m_ofn.lpstrInitialDir = DonutGetFavoriteGroupFolder();
	fileDlg.m_ofn.lpstrTitle	  = _T("CɓO[vɒǉ");

	if (fileDlg.DoModal() == IDOK) {
		_AddGroupOption(fileDlg.m_szFileName);
		::SendMessage(GetTopLevelParent(), WM_REFRESH_EXPBAR, 1, 0);
	}

	// restore current directory
	::SetCurrentDirectory(szOldPath);
}



/**+++FCɓO[vɒǉy[W̃IvVǉ
 */
int  CChildFrame::_AddGroupOption(const CString& strFileName)
{
	CIniFileIO	pr( strFileName, _T("Header") );
	DWORD		dwCount = pr.GetValue( _T("count"), 0 );
	OnSaveOption(strFileName, dwCount);
	++dwCount;
	pr.SetValue( dwCount, _T("count") );
	return dwCount;
}



/** q̃IvViniɃZ[u
 */
void CChildFrame::OnSaveOption(LPCTSTR lpszFileName, int nIndex)
{
	m_view.m_ViewOption.WriteProfile(lpszFileName, nIndex);
}



//vvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// U.H
/**+++:ID_WINDOW_REFRESH_EXCEPT:"̃EBhEȊOXV"
 */
LRESULT CChildFrame::OnWindowRefreshExcept(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
{
	CWaitCursor 		 cur;
	CLockRedrawMDIClient lock(m_hWndMDIClient);
	CLockRedraw 		 lock2(m_MDITab);

	MtlRefreshAllMDIChildrenExcept(m_hWndMDIClient, m_hWnd);
	return 0;
}
//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^


/**+++:Cɓo[̍XV
 */
LRESULT CChildFrame::OnViewRefreshFavBar(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
{
	m_FavMenu.SetRootDirectoryPath( DonutGetFavoritesFolder() );
	m_FavMenu.RefreshMenu();
	return 0;
}


/**+++:ID_EDIT_IGNORE:"|bvAbv}~ɒǉĕ܂B"
 */
void CChildFrame::OnEditIgnore(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
{
	dcfTRACE( _T("CChildFrame::OnEditIgnore\n") );
	CIgnoredURLsOption::Add( GetLocationURL() );
	m_bClosing = true;
	PostMessage(WM_CLOSE);
}


// UDT DGSTR ( close Title , but don't post WM_CLOSE so far. )
/**+++ :^Cg}~ɒǉ
 */
void CChildFrame::OnEditCloseTitle(WORD , WORD , HWND )
{
	ATLTRACE2( atlTraceGeneral, 4, _T("CChildFrame::OnEditCloseTitle\n") );
	CCloseTitlesOption::Add( MtlGetWindowText(m_hWnd) );
	m_bClosing = true;
	PostMessage(WM_CLOSE);
}
// ENDE



/** +++:ny[W߂
 */
void CChildFrame::OnViewBackX(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/)
{
	int 		nStep = (wID - ID_VIEW_BACK1) + 1;
	CLockRedraw lock(m_hWnd);

	for (int i = 0; i < nStep; ++i)
		GoBack();
}



/** +++:ny[Wi
 */
void CChildFrame::OnViewForwardX(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/)
{
	int 		nStep = (wID - ID_VIEW_FORWARD1) + 1;
	CLockRedraw lock(m_hWnd);

	for (int i = 0; i < nStep; ++i)
		GoForward();
}



/**+++:ID_TITLE_COPY:"^CgNbv{[hɃRs[܂B"
 */
void CChildFrame::OnTitleCopy(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/)
{
	MtlSetClipboardText(MtlGetWindowText(m_hWnd), m_hWnd);
}



/**+++:ID_URL_COPY:"AhXNbv{[hɃRs[܂B"
 */
void CChildFrame::OnUrlCopy(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/)
{
	MtlSetClipboardText(GetLocationURL(), m_hWnd);
}



/**+++:ID_COPY_TITLEANDURL:"^CgƃAhXNbv{[hɃRs[܂B"
 */
void CChildFrame::OnTitleAndUrlCopy(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/)
{
	CString strText = MtlGetWindowText(m_hWnd) + _T("\r\n");

	strText += GetLocationURL();
	MtlSetClipboardText(strText, m_hWnd);
}



/** vOXyC̕ݒ
 */
BOOL CChildFrame::SetProgressPaneWidth(int cxWidth)
{
  #if _ATL_VER >= 0x700
	CStatusBarCtrl statusbar   = GetTopLevelParent().GetDlgItem(ATL_IDW_STATUS_BAR);
  #else //+++
	CStatusBarCtrl statusbar   = CWindow( GetTopLevelParent() ).GetDlgItem(ATL_IDW_STATUS_BAR);
  #endif

	const int		nPanes	   = 5;
	//+++ vOXyCƃvLVyČ̕sC.
	int 			nIndex	   = (g_bSwapProxy == 0) ? 1 : 4;

	// get pane positions
	int *			pPanesPos  = (int *) _alloca( nPanes * sizeof (int) );

	statusbar.GetParts(nPanes, pPanesPos);

	// calculate offset
	int 		   cxPaneWidth = pPanesPos[nIndex] - ( (nIndex == 0) ? 0 : pPanesPos[nIndex - 1] );
	int 		   cxOff	   = cxWidth - cxPaneWidth;

	// find variable width pane
	int 		   nDef 	   = 0;

	// resize
	if (nIndex < nDef) {						// before default pane
		for (int i = nIndex; i < nDef; i++)
			pPanesPos[i] += cxOff;
	} else {									// after default one
		for (int i = nDef; i < nIndex; i++)
			pPanesPos[i] -= cxOff;
	}

	// set pane postions
	return	statusbar.SetParts(nPanes, pPanesPos) != 0;
}



// ==========================================================================
// UI

// Update Command UI Handlers
void CChildFrame::OnStyleSheetBaseUI(CCmdUI *pCmdUI)
{
	if (pCmdUI->m_menuSub.m_hMenu) {		// popup menu
		pCmdUI->m_menu.EnableMenuItem(pCmdUI->m_nIndex, MF_BYPOSITION | MF_ENABLED);
	}
}


void CChildFrame::OnUpdateFontSmallestUI(CCmdUI *pCmdUI)
{
	CComVariant 	var;
	ExecWB(OLECMDID_ZOOM, OLECMDEXECOPT_DONTPROMPTUSER, NULL, &var);
	pCmdUI->SetRadio( var == CComVariant(0L) /*? true : false*/);
}


void CChildFrame::OnUpdateFontSmallerUI(CCmdUI *pCmdUI)
{
	CComVariant 	var;
	ExecWB(OLECMDID_ZOOM, OLECMDEXECOPT_DONTPROMPTUSER, NULL, &var);
	pCmdUI->SetRadio( var == CComVariant(1L) /*? true : false*/);
}


void CChildFrame::OnUpdateFontMediumUI(CCmdUI *pCmdUI)
{
	CComVariant 	var;
	ExecWB(OLECMDID_ZOOM, OLECMDEXECOPT_DONTPROMPTUSER, NULL, &var);
	pCmdUI->SetRadio( var == CComVariant(2L) /*? true : false*/);
}


void CChildFrame::OnUpdateFontLargerUI(CCmdUI *pCmdUI)
{
	CComVariant 	var;
	ExecWB(OLECMDID_ZOOM, OLECMDEXECOPT_DONTPROMPTUSER, NULL, &var);
	pCmdUI->SetRadio(var == CComVariant(3L) /*? true : false*/);
}


void CChildFrame::OnUpdateFontLargestUI(CCmdUI *pCmdUI)
{
	if (pCmdUI->m_menuSub.m_hMenu) { // popup menu
		pCmdUI->m_menu.EnableMenuItem(pCmdUI->m_nIndex, MF_BYPOSITION | MF_ENABLED);
	} else {
		CComVariant var;
		ExecWB(OLECMDID_ZOOM, OLECMDEXECOPT_DONTPROMPTUSER, NULL, &var);
		pCmdUI->SetRadio(var == CComVariant(4L) /*? true : false*/);
	}
}

void CChildFrame::OnUpdateStatusBarUI(CCmdUI *pCmdUI)
{
	pCmdUI->SetText(m_strStatusBar);
}


void CChildFrame::OnUpdateSecureUI(CCmdUI *pCmdUI)
{
	CStatusBarCtrl wndStatus = pCmdUI->m_wndOther;

	if (m_nSecureLockIcon != secureLockIconUnsecure) {
		wndStatus.SendMessage(WM_STATUS_SETICON, MAKEWPARAM(ID_SECURE_PANE, 0), 0);

		// c[`bṽZbg
		CString tip = _T("SSL یt ");

		switch (m_nSecureLockIcon) {
		case secureLockIconUnsecure:			tip  = "";					break;
		case secureLockIconMixed:				tip += _T("(j");		break;
		case secureLockIconSecureUnknownBits:	tip += _T("(sj");		break;
		case secureLockIconSecure40Bit: 		tip += _T("(40rbg)");	break;
		case secureLockIconSecure56Bit: 		tip += _T("(56rbg)");	break;
		case secureLockIconSecureFortezza:		tip += _T("(Fortezza)");	break;
		case secureLockIconSecure128Bit:		tip += _T("(128rbg)");	break;
		default:								tip  = "";
		}
		wndStatus.SendMessage( WM_STATUS_SETTIPTEXT, (WPARAM) ID_SECURE_PANE, (LPARAM) tip.GetBuffer(0) );

	} else {
		wndStatus.SendMessage(WM_STATUS_SETICON, MAKEWPARAM(ID_SECURE_PANE, -1), 0);
	}
}


void CChildFrame::OnUpdatePrivacyUI(CCmdUI *pCmdUI)
{
	CStatusBarCtrl wndStatus = pCmdUI->m_wndOther;

	if (m_bPrivacyImpacted == FALSE)
		wndStatus.SendMessage(WM_STATUS_SETICON, MAKEWPARAM(ID_PRIVACY_PANE, 1), 0);
	else
		wndStatus.SendMessage(WM_STATUS_SETICON, MAKEWPARAM(ID_PRIVACY_PANE, -1), 0);

	wndStatus.SendMessage( WM_STATUS_SETTIPTEXT, (WPARAM) ID_PRIVACY_PANE, (LPARAM) _T("vCoV[ |[g") );
}


///+++ :y[Wǂݍ݃vOXo[̏ԍXV.
void CChildFrame::OnProgressChange(long progress, long progressMax)
{
	m_nProgress    = progress;
	m_nProgressMax = progressMax;
}



///+++ :y[Wǂݍ݃vOXo[̕\
void CChildFrame::OnUpdateProgressUI(CCmdUI *pCmdUI)
{
	CProgressBarCtrl progressbar = pCmdUI->m_wndOther;
	CStatusBarCtrl	 statusbar	 = pCmdUI->m_wndOther.GetParent();


	if ( m_nProgress == -1 || (m_nProgress == 0 && m_nProgressMax == 0) ) {
		if (g_bSwapProxy == 0) {		//+++ ʏ(ɂ)̂ݕ0ɂ. vLVƈʒuĂƂ͂.
			SetProgressPaneWidth(0);
			progressbar.ShowWindow(SW_HIDE);
		} else {						//+++ ĂƂ́AƂ肠A0ŏoςȂőΏ.
			progressbar.SetPos(0);		//+++ Q[Wo[̂͏Ă
		}
		return;
	}

	CRect			 rcProgressPart;
	if (g_bSwapProxy == false)
		statusbar.GetRect(1, rcProgressPart);
	else
		statusbar.GetRect(4, rcProgressPart);

	rcProgressPart.DeflateRect(2, 2);
	progressbar.MoveWindow(rcProgressPart, TRUE);
	progressbar.SetRange32(0, m_nProgressMax);
	//x 0ɂȂĂƂɖt[SetPos(0)悤ɂ̂ŁAł͕sv
	//x (ƂAłől`悪s悤ɂ邽߁Aق悢)
	//x if (m_nProgress >= m_nProgressMax && m_nProgressMax && g_bSwapProxy)
	//x progressbar.SetPos(0);
	//x else
	progressbar.SetPos(m_nProgress);
	progressbar.ShowWindow(SW_SHOWNORMAL);

	//+++ TCYŒŃIvVݒł̃TCYfĂȂ̂ł𔽉f. O[oϐȂ̂͂Ƃ肠...
	SetProgressPaneWidth( g_dwProgressPainWidth );
}



// ==========================================================================
// gvpeB

BYTE CChildFrame::GetTabItemState(HWND hTarWnd)
{
	int  nTabIndex = m_MDITab.GetTabIndex(hTarWnd);
	BYTE bytData   = 0;

	m_MDITab.GetItemState(nTabIndex, bytData);
	return bytData;
}



LRESULT CChildFrame::OnGetExtendedTabStyle()
{
	DWORD dwFlags		 = 0;
	DWORD dwDLFlags 	 = m_view.GetDLControlFlags();
	DWORD dwViewExStyle  = m_view.m_ViewOption.m_dwExStyle;
	DWORD dwRefreshStyle = m_view.m_ViewOption.m_dwAutoRefreshStyle;

	if (dwDLFlags & DLCTL_DLIMAGES) 				dwFlags |= FLAG_SE_DLIMAGES;
	if (dwDLFlags & DLCTL_VIDEOS)					dwFlags |= FLAG_SE_VIDEOS;
	if (dwDLFlags & DLCTL_BGSOUNDS) 				dwFlags |= FLAG_SE_BGSOUNDS;
	if ( !(dwDLFlags & DLCTL_NO_RUNACTIVEXCTLS) )	dwFlags |= FLAG_SE_RUNACTIVEXCTLS;
	if ( !(dwDLFlags & DLCTL_NO_DLACTIVEXCTLS) )	dwFlags |= FLAG_SE_DLACTIVEXCTLS;
	if ( !(dwDLFlags & DLCTL_NO_SCRIPTS) )			dwFlags |= FLAG_SE_SCRIPTS;
	if ( !(dwDLFlags & DLCTL_NO_JAVA) ) 			dwFlags |= FLAG_SE_JAVA;
	if (dwViewExStyle & DVS_EX_OPENNEWWIN)			dwFlags |= FLAG_SE_NAVIGATELOCK;
	if (dwViewExStyle & DVS_EX_FLATVIEW)			dwFlags |= FLAG_SE_FLATVIEW;
	if (dwViewExStyle & DVS_EX_MESSAGE_FILTER)		dwFlags |= FLAG_SE_MSGFILTER;
	if (dwViewExStyle & DVS_EX_MOUSE_GESTURE)		dwFlags |= FLAG_SE_MOUSEGESTURE;
	if (dwViewExStyle & DVS_EX_BLOCK_MAILTO)		dwFlags |= FLAG_SE_BLOCKMAILTO;

	BYTE bytState = GetTabItemState(m_hWnd);
	if ( !(bytState & TCISTATE_INACTIVE) )			dwFlags |= FLAG_SE_VIEWED;

	if (dwRefreshStyle == 0)
		dwFlags |= FLAG_SE_REFRESH_NONE;
	else
		dwFlags |= ( dwRefreshStyle * ( FLAG_SE_REFRESH_15 / DVS_AUTOREFRESH_15SEC) );

	return dwFlags;
}



void CChildFrame::OnSetExtendedTabStyle(DWORD dwStyle)
{
	DWORD dwDLFlags 	 = m_view.GetDLControlFlags();
	DWORD dwViewExStyle  = m_view.m_ViewOption.m_dwExStyle;
	DWORD dwRefreshStyle = ( dwStyle /	( FLAG_SE_REFRESH_15 / DVS_AUTOREFRESH_15SEC) ) & DVS_AUTOREFRESH_OR;

	if (dwStyle & FLAG_SE_DLIMAGES) 		dwDLFlags |=  DLCTL_DLIMAGES;
	else									dwDLFlags &= ~DLCTL_DLIMAGES;
	if (dwStyle & FLAG_SE_VIDEOS)			dwDLFlags |=  DLCTL_VIDEOS;
	else									dwDLFlags &= ~DLCTL_VIDEOS;
	if (dwStyle & FLAG_SE_BGSOUNDS) 		dwDLFlags |=  DLCTL_BGSOUNDS;
	else									dwDLFlags &= ~DLCTL_BGSOUNDS;
	if (dwStyle & FLAG_SE_RUNACTIVEXCTLS)	dwDLFlags &= ~DLCTL_NO_RUNACTIVEXCTLS;
	else									dwDLFlags |=  DLCTL_NO_RUNACTIVEXCTLS;
	if (dwStyle & FLAG_SE_DLACTIVEXCTLS)	dwDLFlags &= ~DLCTL_NO_DLACTIVEXCTLS;
	else									dwDLFlags |=  DLCTL_NO_DLACTIVEXCTLS;
	if (dwStyle & FLAG_SE_SCRIPTS)			dwDLFlags &= ~DLCTL_NO_SCRIPTS;
	else									dwDLFlags |=  DLCTL_NO_SCRIPTS;
	if (dwStyle & FLAG_SE_JAVA) 			dwDLFlags &= ~DLCTL_NO_JAVA;
	else									dwDLFlags |=  DLCTL_NO_JAVA;

	if (dwStyle & FLAG_SE_NAVIGATELOCK) 	dwViewExStyle |=  DVS_EX_OPENNEWWIN;
	else									dwViewExStyle &= ~DVS_EX_OPENNEWWIN;
	if (dwStyle & FLAG_SE_FLATVIEW) 		dwViewExStyle |=  DVS_EX_FLATVIEW;
	else									dwViewExStyle &= ~DVS_EX_FLATVIEW;			//* +++  ~ Ȃ̂̓UƂȂ̂oOȂ̂? 炭oO낤~Ƃ.
	if (dwStyle & FLAG_SE_MSGFILTER)		dwViewExStyle |=  DVS_EX_MESSAGE_FILTER;
	else									dwViewExStyle &= ~DVS_EX_MESSAGE_FILTER;
	if (dwStyle & FLAG_SE_MOUSEGESTURE) 	dwViewExStyle |=  DVS_EX_MOUSE_GESTURE;
	else									dwViewExStyle &= ~DVS_EX_MOUSE_GESTURE;
	if (dwStyle & FLAG_SE_BLOCKMAILTO)		dwViewExStyle |=  DVS_EX_BLOCK_MAILTO;
	else									dwViewExStyle &= ~DVS_EX_BLOCK_MAILTO;

	int nIndex = m_MDITab.GetTabIndex(m_hWndA);

	if (dwStyle & FLAG_SE_VIEWED)
		m_MDITab.SetItemActive(nIndex);
	else
		m_MDITab.SetItemInactive(nIndex);

	//irQ[gbN̕ύX𔽉f
	// if ( (m_view.m_ViewOption.m_dwExStyle & DVS_EX_OPENNEWWIN) != (dwStyle & FLAG_SE_NAVIGATELOCK) )
	//+++ Ȃɂ悭킩ɂ...DVS_EX_OPENNEWWIN=0x01, FLAG_SE_NAVIGATELOCK=0x80Ȃ̂ŁA
	//+++ !=UɂȂ̂͗ӂ0̂Ƃ̂...Ȃ̂ŁAǂ炩onɂȂĂif̒ɂ͂.
	//+++ Ƃ肠Â悤ɋLqȂ
	if ( (m_view.m_ViewOption.m_dwExStyle & DVS_EX_OPENNEWWIN) || (dwStyle & FLAG_SE_NAVIGATELOCK) )
	{
		m_MDITab.NavigateLockTab(m_hWnd, (dwStyle & FLAG_SE_NAVIGATELOCK) != 0/*? true : false*/);
	}

	m_MDITab.InvalidateRect(NULL);

	//tOύX
	m_view.PutDLControlFlags(dwDLFlags);
	m_view.m_ViewOption.m_dwExStyle = dwViewExStyle;
	m_view.m_ViewOption.SetAutoRefreshStyle(dwRefreshStyle);

	//ύXKp邽߂ɃtbV
	//m_view.Navigate2(m_view.GetLocationURL());
	if ( !(dwStyle & FLAG_SE_NOREFRESH) )
		::SendMessage(m_hWnd, WM_COMMAND, (WPARAM) (ID_VIEW_REFRESH & 0xFFFF), 0);
}



void CChildFrame::SetViewExStyle(DWORD dwStyle, BOOL bExProp /*= FALSE*/)
{
	bool bNavigateLock = (dwStyle & DVS_EX_OPENNEWWIN) != 0/*? true : false*/;

	m_MDITab.NavigateLockTab(m_hWnd, bNavigateLock);
	m_view.m_ViewOption.m_dwExStyle = dwStyle;
	m_bExPropLock					= (bNavigateLock && bExProp) /*? true : false*/;
}



// ==========================================================================
// iޖ߂


void	CChildFrame::SetDfgFileNameSection(const CString &strFileName, const CString &strSection)
{
	m_strDfgFileName = strFileName;
	m_strSection	 = strSection;
}



void CChildFrame::SetArrayHist(
			std::vector< std::pair<CString, CString> > &	ArrayFore,
			std::vector< std::pair<CString, CString> > &	ArrayBack
){
	m_ArrayHistFore = ArrayFore;
	m_ArrayHistBack = ArrayBack;
}



void CChildFrame::SetTravelLogData()
{
	if (m_bInitTravelLog) {
		if (m_ArrayHistBack.size() == 0 && m_ArrayHistFore.size() == 0) {
			//iniǂݍ
			std::vector<std::pair<CString, CString> > ArrFore;
			std::vector<std::pair<CString, CString> > ArrBack;
			_Load_TravelData(ArrFore, ArrBack, m_strDfgFileName, m_strSection);
			_Load_TravelLog(ArrFore, m_spBrowser, TRUE);
			_Load_TravelLog(ArrBack, m_spBrowser, FALSE);
		} else {
			//z̃f[^g
			_Load_TravelLog(m_ArrayHistFore, m_spBrowser, TRUE);
			_Load_TravelLog(m_ArrayHistBack, m_spBrowser, FALSE);
			m_ArrayHistBack.clear();
			m_ArrayHistFore.clear();
		}
	}

	m_bInitTravelLog = FALSE;
}



BOOL CChildFrame::_Load_TravelData(
	std::vector<std::pair<CString, CString> >&	arrFore,
	std::vector<std::pair<CString, CString> >&	arrBack,
	CString & 									strFileName,
	CString & 									strSection)
{
	if ( strFileName.IsEmpty() )
		return FALSE;

	if ( strSection.IsEmpty() )
		return FALSE;

	CIniFileI	pr(strFileName, strSection);
	CString 		strKey;
	for (unsigned i = 0; i < 0x7fffffff; ++i) {
		strKey.Format(_T("Fore_URL%d"), i);
		CString strURL = pr.GetString(strKey/*, NULL, MAX_PATH*/);
		if (strURL.IsEmpty())
			break;
		strKey.Format(_T("Fore_Title%d"), i);
		CString strTitle = pr.GetStringUW(strKey/*, NULL, 1024*/);
		if (strTitle.IsEmpty())
			break;
		arrFore.push_back( std::make_pair(strTitle, strURL) );
	}

	for (unsigned i = 0; i < 0x7fffffff; ++i) {
		strKey.Format(_T("Back_URL%d"), i);
		CString strURL = pr.GetString(strKey/*, NULL, MAX_PATH*/);
		if (strURL.IsEmpty())
			break;
		strKey.Format(_T("Back_Title%d"), i);
		CString strTitle = pr.GetStringUW(strKey/*, NULL, 1024*/);
		if (strTitle.IsEmpty())
			break;
		arrBack.push_back( std::make_pair(strTitle, strURL) );
	}

	return TRUE;
}



BOOL CChildFrame::_Load_TravelLog(
	std::vector<std::pair<CString, CString> >&	arrLog,
	CComPtr<IWebBrowser2> 						pWB2,
	BOOL 										bFore)
{
	if (arrLog.size() == 0)
		return FALSE;

	HRESULT 					 hr;
	CComPtr<IServiceProvider>	 pISP;
	CComPtr<ITravelLogStg>		 pTLStg;
	CComPtr<IEnumTravelLogEntry> pTLEnum;
	CComPtr<ITravelLogEntry>	 pTLEntryBase = NULL;
	int 						 nDir;

	nDir   = bFore ? TLEF_RELATIVE_FORE : TLEF_RELATIVE_BACK;

	if (pWB2 == NULL)
		return FALSE;

	hr	   = pWB2->QueryInterface(IID_IServiceProvider, (void **) &pISP);
	if (FAILED(hr) || pISP == NULL)
		return FALSE;

	hr	   = pISP->QueryService(SID_STravelLogCursor, IID_ITravelLogStg, (void **) &pTLStg);
	if (FAILED(hr) || pTLStg == NULL)
		return FALSE;

	hr	   = pTLStg->EnumEntries(nDir, &pTLEnum);
	if (FAILED(hr) || pTLEnum == NULL)
		return FALSE;

	int		nLast	= ( 10 > arrLog.size() ) ? (int) arrLog.size() : 10;
	for (int i = 0; i < nLast; i++) {
		CComPtr<ITravelLogEntry> pTLEntry;

	  #if 1	//+++ UNICODE Ή.
		std::vector<wchar_t>	title = Misc::tcs_to_wcs( LPCTSTR( arrLog[i].first ) );
		std::vector<wchar_t>	url   = Misc::tcs_to_wcs( LPCTSTR( arrLog[i].second) );
		hr			 = pTLStg->CreateEntry(&url[0], &title[0], pTLEntryBase, !bFore, &pTLEntry);
	  #else
		CString 	strTitle	= arrLog[i].first;
		CString 	strURL		= arrLog[i].second;

		LPOLESTR				 pszwURL   = _ConvertString(strURL, strURL.GetLength() + 1);		//new
		LPOLESTR				 pszwTitle = _ConvertString(strTitle, strTitle.GetLength() + 1);	//new

		hr			 = pTLStg->CreateEntry(pszwURL, pszwTitle, pTLEntryBase, !bFore, &pTLEntry);
		delete[] pszwURL;																			//Don't forget!
		delete[] pszwTitle;
	  #endif

		if (FAILED(hr) || pTLEntry == NULL)
			return FALSE;

		if (pTLEntryBase)
			pTLEntryBase.Release();

		pTLEntryBase = pTLEntry;
	}

	return TRUE;
}



#if 0	//+++ UNICODEΉ̐܁Asv
LPOLESTR CChildFrame::_ConvertString(LPCTSTR lpstrBuffer, int nBufferSize)
{
	LPOLESTR pszwDest = new OLECHAR[ nBufferSize ];

	::MultiByteToWideChar( CP_ACP, 0, lpstrBuffer, nBufferSize, pszwDest, nBufferSize * sizeof (OLECHAR) );
	return pszwDest;
}
#endif




// ===========================================================================
// g֌W

/// 摜t@CȂIE̐ݒɂăTCY
void CChildFrame::CheckImageAutoSize(const CString* pStrURL, BOOL bFirst)
{
	CString 	strExt = pStrURL ? MtlGetExt(*pStrURL, false) : CString("");
	strExt.MakeLower();

	m_bImg = false;	//+++
	if ( m_nImgWidth != -1
	   || strExt == _T("bmp") || strExt == _T("jpg") || strExt == _T("jpeg")
	   || strExt == _T("gif") || strExt == _T("png") )
	{
	  #if 1	//+++ TCY̗ĹAIẼWXgݒQ.
		//if (CMainOption::s_bStretchImage)
		{
			CRegKey 	rk;
			LONG		lRet  = rk.Open( HKEY_CURRENT_USER, _T("Software\\Microsoft\\Internet Explorer\\Main") );
			if (lRet != ERROR_SUCCESS)
				return;
			TCHAR	buf[32];
			ULONG	num = 30;
			lRet = rk.QueryStringValue(_T("Enable AutoImageResize"), buf, &num);
			//if (memcmp(buf, "yes", 4) != 0)		//+++ yes ȊOݒ肳Ăno
			if (memcmp(buf, "no", 4) == 0)		//+++ noݒ肳ĂABȊOyes.(WXgȂƂyes̈ɂ邽)
				return;
		}
	  #endif
		m_nImgScl	= 100;		//+++

	  #if 1	//+++ ƂĂ݂...
		CComPtr<IHTMLDocument2> 			pDoc;
		if ( FAILED( m_spBrowser->get_Document( (IDispatch **) &pDoc ) ) )
			return;

		CComPtr<IHTMLElementCollection> 	pElemClct;
		if ( FAILED( pDoc->get_images(&pElemClct) ) )
			return;

		long	length = 0;
		pElemClct->get_length(&length);

		CComPtr<IDispatch>			pDisp;
		CComPtr<IHTMLImgElement>	pImg;
		CComVariant 				varName ( (long) 0 );
		CComVariant 				varIndex( (long) 0 );
		if ( FAILED( pElemClct->item(varName, varIndex, &pDisp) ) )
			return;
		if (!pDisp)		//+++ sNULL̂Ƃ悤ȂŃ`FbN
			return;
		if ( FAILED( pDisp->QueryInterface(&pImg) ) )
			return;

		long	Width  = m_nImgWidth;
		long	Height = m_nImgHeight;
		if (bFirst) {
			if ( FAILED( pImg->get_width(&Width) ) )
				return;
			if ( FAILED( pImg->get_height(&Height) ) )
				return;
			m_nImgWidth  = Width;
			m_nImgHeight = Height;
		}

		CComPtr<IHTMLElement>	spHTMLElement;
		if ( FAILED( pDoc->get_body(&spHTMLElement) ) )
			return;
		if (!spHTMLElement)
			return;
		CComPtr<IHTMLElement2>  spHTMLElement2;
		if ( FAILED( spHTMLElement->QueryInterface(&spHTMLElement2)) )
			return;
		if (!spHTMLElement2)
			return;

		long 	scWidth  = 0;
		long 	scHeight = 0;
	   #if 1	//+++
		if ( FAILED( m_spBrowser->get_Width(&scWidth) ) )
			return;
		if ( FAILED( m_spBrowser->get_Height(&scHeight) ) )
			return;
	   #else	// clientWidth,Height̒lA܂ɂւȒlAĂ...
		if ( FAILED(spHTMLElement2->get_clientWidth (&scWidth )) )
			return;
		if ( FAILED(spHTMLElement2->get_clientHeight(&scHeight)) )
			return;
	   #endif

		m_bImg		= true;		//+++

		enum { MGN = 20/*32*/ };
		scWidth  = (scWidth  - MGN < 0) ? 1 : scWidth  - MGN;
		scHeight = (scHeight - MGN < 0) ? 1 : scHeight - MGN;

		//if (scWidth < Width || scHeight < Height)
		{
			double  sclW = scWidth  * 100.0 / Width;
			double  sclH = scHeight * 100.0 / Height;
			double  scl  = sclW < sclH ? sclW : sclH;
			if (scl < 1) {
				scl = 1;
			} else if (scl >= 100) {
				scl			= 100;
				m_nImgSclSav = 100;
			}
			if (m_nImgSclSw == 0) {
				m_nImgSclSav = scl;
				m_nImgSclSw  = 0;
				scl			 = 100;
			}
			m_nImgScl = int( scl );
			wchar_t		wbuf[128];
			swprintf(wbuf, 128, L"%d%%", int(scl));
			CComVariant variantVal(wbuf);
			CComBSTR	bstrZoom( L"zoom" );

			CComPtr<IHTMLStyle>		pHtmlStyle;
			if ( FAILED(spHTMLElement2->get_runtimeStyle(&pHtmlStyle)) )
				return;
			if (!pHtmlStyle)
				return;
			pHtmlStyle->setAttribute(bstrZoom, variantVal, 1);
		}
	  #else	//+++ ...
	  #endif
	}
}



///+++
LRESULT CChildFrame::OnHtmlZoomMenu(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
{
	::SetForegroundWindow(m_hWnd);
	CMenu/*Handle*/ 	menu0;
	menu0.LoadMenu(IDR_ZOOM_MENU);
	if (menu0.m_hMenu == NULL)
		return 0;
	CMenuHandle menu = menu0.GetSubMenu(0);
	if (menu.m_hMenu == NULL)
		return 0;

	// |bvAbvj[J.
	POINT 	pt;
	::GetCursorPos(&pt);
	HRESULT hr = menu.TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON| TPM_RETURNCMD, pt.x, pt.y, m_hWnd, NULL);
	if (hr)
		MtlSendCommand(m_hWnd, WORD(hr));
	return 0;
}



///+++
LRESULT CChildFrame::OnHtmlZoomAdd(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
{
	SetBodyStyleZoom(10, 0);
	return 0;
}



///+++
LRESULT CChildFrame::OnHtmlZoomSub(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
{
	SetBodyStyleZoom(-10, 0);
	return 0;
}



///+++ 100% Ƃ̑̔䗦gOؑ.
LRESULT CChildFrame::OnHtmlZoom100Togle(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL &)
{
	if (m_nImgScl == 100) {
		m_nImgScl	 = m_nImgSclSav;
		m_nImgSclSw	 = 1;
	} else {
		m_nImgSclSav = m_nImgScl;
		m_nImgScl    = 100;
		m_nImgSclSw	 = 0;
	}
	SetBodyStyleZoom(0, m_nImgScl);
	return 0;
}



///+++
void CChildFrame::OnHtmlZoom(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/)
{
	ATLASSERT(wID >= ID_HTMLZOOM_400 && wID <= ID_HTMLZOOM_050);
	static const int scls[] = { 400, 200, 150, 125, 100, 75, 50 };
	int  n = wID - ID_HTMLZOOM_400;
	if (n < 0 || n > ID_HTMLZOOM_050-ID_HTMLZOOM_400)
		return;
	SetBodyStyleZoom(0, scls[n]);
	return;
}



///+++ htmlgk
void CChildFrame::SetBodyStyleZoom(int addSub, int scl)
{
	CComPtr<IHTMLDocument2> 			pDoc;
	if ( FAILED( m_spBrowser->get_Document( (IDispatch **) &pDoc ) ) )
		return;

	CComPtr<IHTMLElement>	spHTMLElement;
	if ( FAILED( pDoc->get_body(&spHTMLElement) ) )
		return;
	if (!spHTMLElement)
		return;
	CComPtr<IHTMLElement2>  spHTMLElement2;
	if ( FAILED( spHTMLElement->QueryInterface(&spHTMLElement2)) )
		return;
	if (!spHTMLElement2)
		return;

	CComPtr<IHTMLStyle>		pHtmlStyle;
	if ( FAILED(spHTMLElement2->get_runtimeStyle(&pHtmlStyle)) )
		return;
	if (!pHtmlStyle)
		return;

	wchar_t		wbuf[128];
	wbuf[0] = 0;
	CComVariant variantVal; //(wbuf);
	CComBSTR	bstrZoom( L"zoom" );
	if (addSub) {
		if ( FAILED(pHtmlStyle->getAttribute(bstrZoom, 1, &variantVal)) )
			return;
		CComBSTR	bstrTmp(variantVal.bstrVal);
		scl =  !bstrTmp.m_str ? 100 : wcstol((wchar_t*)LPCWSTR(bstrTmp.m_str), 0, 10);
		scl += addSub;
	}
	if (scl < 5)
		scl = 5;
	else if (scl > 500)
		scl = 500;

	m_nImgScl = scl;

	swprintf(wbuf, 128, L"%d%%", int(scl));
	variantVal = CComVariant(wbuf);

	pHtmlStyle->setAttribute(bstrZoom, variantVal, 1);
}




// ===========================================================================
// X^CV[g

LRESULT CChildFrame::OnChangeCSS(LPCTSTR lpszStyleSheet)
{
	CString strSheetPath(lpszStyleSheet);
	CString strSheetName = strSheetPath.Mid(strSheetPath.ReverseFind('\\') + 1);

	StyleSheet(strSheetName, FALSE, strSheetPath);

	SetDefaultStyleSheet(strSheetPath);

	return 1;
}


LRESULT CChildFrame::OnStyleSheet(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
{
	CString strSheet;
	BOOL	bOff = FALSE;

	switch (wID) {
	case ID_STYLESHEET_BASE:
		break;
	case ID_STYLESHEET_OFF:
		bOff = TRUE;
		break;
	}

	StyleSheet( strSheet, bOff, _T("") );
	SetDefaultStyleSheet( _T("") );

	return 1;
}



void CChildFrame::SetDefaultStyleSheet(const CString& strStyleSheet)
{
	CIniFileIO	pr( g_szIniFileName, _T("StyleSheet") );
	DWORD		dwSetDefault = pr.GetValue( _T("SetDefault") );
	if (dwSetDefault)
		pr.SetString( strStyleSheet, _T("Default") );
}



//public:
void CChildFrame::StyleSheet(CString strSheet, BOOL bOff, CString strSheetPath)
{
	CComPtr<IDispatch>		spDisp;
	HRESULT 				hr = m_spBrowser->get_Document(&spDisp);
	if ( FAILED(hr) )
		return;

	CComPtr<IHTMLDocument2> spDocument;
	hr = spDisp->QueryInterface(&spDocument);
	if ( FAILED(hr) )
		return;

	StyleSheetRecursive(spDocument, strSheet, bOff, strSheetPath);
}


//private:
void CChildFrame::StyleSheetRecursive(CComPtr<IHTMLDocument2> spDocument, CString strSheet, BOOL bOff, CString strSheetPath)
{
	if ( !CheckFrameDefinePage(spDocument) )
		StyleSheetSub(spDocument, strSheet, bOff, strSheetPath);

	HRESULT 	hr;
	CComPtr<IHTMLFramesCollection2> spFrames;
	hr = spDocument->get_frames(&spFrames);

	// cf. Even if no frame, get_frames would succeed.
	if ( FAILED(hr) )
		return;

	long		nCount = 0;
	hr = spFrames->get_length(&nCount);
	if ( FAILED(hr) )
		return;

	for (LONG ii = 0; ii < nCount; ii++) {
		CComVariant 	varItem(ii);
		CComVariant 	varResult;

		hr = spFrames->item(&varItem, &varResult);
		if ( FAILED(hr) )
			continue;

		CComQIPtr<IHTMLWindow2> 	spWindow = varResult.pdispVal;
		if (!spWindow)
			continue;

		CComPtr<IHTMLDocument2> 	spDocumentFr;
		hr = spWindow->get_document(&spDocumentFr);
		if ( FAILED(hr) )
			continue;

		StyleSheetRecursive(spDocumentFr, strSheet, bOff, strSheetPath);
	}
}


BOOL CChildFrame::CheckFrameDefinePage(CComPtr<IHTMLDocument2> spDocument)
{
	HRESULT 	hr;
	CComPtr<IHTMLElementCollection> 	spClct;
	hr = spDocument->get_all(&spClct);

	if ( SUCCEEDED(hr) ) {
		CComVariant 	   varStr( CComBSTR( _T("frameSet") ) );
		CComPtr<IDispatch> spDisp;
		hr = spClct->tags(varStr, &spDisp);

		if (SUCCEEDED(hr) && spDisp) {
			CComQIPtr<IHTMLElementCollection> spFrameSetClct = spDisp;
			LONG							  lCount		 = 0;
			hr = spFrameSetClct->get_length(&lCount);

			if (SUCCEEDED(hr) && lCount)
				return TRUE;
		}
	}

	return FALSE;
}


void CChildFrame::StyleSheetSub(IHTMLDocument2 *pDocument, CString strSheet, BOOL bOff, CString strSheetPath)
{
	// X^CV[gꗗ擾
	CComPtr<IHTMLStyleSheetsCollection> spSheetsColl;
	pDocument->get_styleSheets(&spSheetsColl);

	if (!spSheetsColl)
		return;

	bool	bFindTarSheet = false;
	long	lLength;
	spSheetsColl->get_length(&lLength);

	for (long i = 0; i < lLength; i++) {
		VARIANT varIdx, varSheet;
		varIdx.vt		  = VT_I4;
		varIdx.lVal 	  = i;
		varSheet.vt 	  = VT_DISPATCH;
		varSheet.pdispVal = NULL;
		spSheetsColl->item(&varIdx, &varSheet);

		if (varSheet.pdispVal) {
			CComPtr<IHTMLStyleSheet> spSheet2 = NULL;
			varSheet.pdispVal->QueryInterface(IID_IHTMLStyleSheet, (void **) &spSheet2);

			CComBSTR	strTitle;
			spSheet2->get_title(&strTitle);

			CString 	strTarSheet(strTitle);

			if (strTarSheet == strSheet && !bOff) {
				spSheet2->put_disabled(VARIANT_FALSE);
				bFindTarSheet = true;
			} else {
				spSheet2->put_disabled(VARIANT_TRUE);
			}
		}

		varSheet.pdispVal->Release();
	}

	if ( !bFindTarSheet && !bOff && !strSheetPath.IsEmpty() ) {
		CComPtr<IHTMLStyleSheet> spSheet;
		pDocument->createStyleSheet(NULL, -1, &spSheet);

		if (spSheet) {
			// ݒ
			long lPos;
			spSheet->addImport( (BSTR) CComBSTR(strSheetPath), -1, &lPos );
			spSheet->put_title( (BSTR) CComBSTR(strSheet) );
			spSheet->put_disabled(VARIANT_FALSE);
		}
	}
}


//private:
void CChildFrame::ApplyDefaultStyleSheet()
{
	CIniFileI pr( g_szIniFileName, _T("StyleSheet") );
	CString 	strSheet = pr.GetString(_T("Default"));
	pr.Close();

	if ( !strSheet.IsEmpty() ) {
		StyleSheet(MtlGetFileName(strSheet), FALSE, strSheet);
	}
}



// ===========================================================================
// ͈͑I֌W


///+++ t[̊ey[ẂAI͈͂̕擾(ׂĂr߂邪A󋵓IɌ̂͂P̂͂j
struct Function_GetSelectedText {

	Function_GetSelectedText(CString& rSel) : m_rStrSelText(rSel) {;}

	void operator ()(IHTMLDocument2 *pDocument)
	{
		CComPtr<IHTMLSelectionObject>		spSelection;
		HRESULT 	hr	= pDocument->get_selection(&spSelection);
		if ( SUCCEEDED( hr ) ) {
			CComPtr<IDispatch>				spDisp;
			hr	   = spSelection->createRange(&spDisp);
			if ( SUCCEEDED( hr ) ) {
				CComQIPtr<IHTMLTxtRange>	spTxtRange = spDisp;
				if (spTxtRange) {
					CComBSTR				bstrText;
					hr	   = spTxtRange->get_text(&bstrText);
					if (SUCCEEDED(hr) && !!bstrText)
						m_rStrSelText = CString(bstrText);
				}
			}
		}
	}

private:
	CString&		m_rStrSelText;
};


///+++ I͈͂̕擾(t[Ή)
CString CChildFrame::GetSelectedText()
{
	CString 	strSelText;
	//m_MDITab.SetLinkState(LINKSTATE_B_ON);
	MtlForEachHTMLDocument2( m_spBrowser, Function_GetSelectedText(strSelText) );
	//m_MDITab.SetLinkState(LINKSTATE_OFF);

	if (strSelText.IsEmpty()) {
		//+++ I͈͂ȂꍇAENbNj[oR̂Ƃ̂ŁA΍...
		CCustomContextMenu* pMenu = CCustomContextMenu::GetInstance();
		if (pMenu && pMenu->GetContextMenuMode() == CONTEXT_MENU_ANCHOR && pMenu->GetAnchorUrl().IsEmpty() == 0) {
			//bstrText		= pMenu->GetAnchorUrl();
			//bstrLocationUrl = pMenu->GetAnchorUrl();
			strSelText = CString(pMenu->GetAnchorUrl());
		}
	}
	return strSelText;
}



//+++ _OpenSelectedText()蕪.
CString CChildFrame::GetSelectedTextLine()
{
	CString str = GetSelectedText();
	if (str.IsEmpty() == 0) {
		int 	n	= str.Find(_T("\r"));
		int 	n2	= str.Find(_T("\n"));
		if ((n < 0 || n > n2) && n2 >= 0)
			n = n2;
		if (n >= 0) {
			str = str.Left(n);
		}
	}
	return str;
}




struct CChildFrame::_Function_OpenSelectedRef {
private:
	HWND			m_hWnd;
	CChildFrame*	m_pChild;

public:
	_Function_OpenSelectedRef(HWND hWnd, CChildFrame* pChild) : m_hWnd(hWnd), m_pChild(pChild) { }

	void operator ()(IHTMLDocument2 *pDocument)
	{
		CComPtr<IHTMLSelectionObject>	spSelection;
		HRESULT 	hr	= pDocument->get_selection(&spSelection);
		if ( FAILED(hr) )
			return;

		CComPtr<IDispatch>				spDisp;
		hr = spSelection->createRange(&spDisp);
		if ( FAILED(hr) )
			return;

		CComQIPtr<IHTMLTxtRange>		spTxtRange = spDisp;
		if (!spTxtRange)
			return;

		CSimpleArray<CString>			arrUrl;
		CComBSTR						bstrLocationUrl;
		CComBSTR						bstrText;
		hr = spTxtRange->get_htmlText(&bstrText);
		if (FAILED(hr) || !bstrText) {	//+++
		  #if 1 //+++ I͈͂ȂꍇAENbNj[oR̂Ƃ̂ŁA΍...
			CCustomContextMenu* pMenu = CCustomContextMenu::GetInstance();
			if (pMenu && pMenu->GetContextMenuMode() == CONTEXT_MENU_ANCHOR && pMenu->GetAnchorUrl().IsEmpty() == 0) {
				//bstrText		= pMenu->GetAnchorUrl();
				//bstrLocationUrl = pMenu->GetAnchorUrl();
				arrUrl.Add(pMenu->GetAnchorUrl());
			} else {
				return;
			}
		  #else
			return;
		  #endif
		} else {
			hr = pDocument->get_URL(&bstrLocationUrl);
			if ( FAILED(hr) )
				return;

			//BASE^OɑΏ minit
			CComPtr<IHTMLElementCollection> spAllClct;
			hr = pDocument->get_all(&spAllClct);
			if ( SUCCEEDED(hr) ) {
				CComPtr<IHTMLElementCollection> spBaseClct;
				CComVariant 					val = _T("BASE");
				hr = spAllClct->tags(val, (IDispatch **) &spBaseClct);

				if ( SUCCEEDED(hr) ) {
					long	length;
					spBaseClct->get_length(&length);
					if (length > 0) {
						CComPtr<IHTMLElement> spElem;
						CComVariant 		  val1( (int) 0 ), val2( (int) 0 );
						hr = spBaseClct->item(val1, val2, (IDispatch **) &spElem);
						if ( SUCCEEDED(hr) ) {
							CComPtr<IHTMLBaseElement> spBase;
							hr = spElem->QueryInterface(&spBase);
							if ( SUCCEEDED(hr) ) {
								CComBSTR bstrBaseUrl;
								hr = spBase->get_href(&bstrBaseUrl);
								if ( SUCCEEDED(hr) && !(!bstrBaseUrl) )
									bstrLocationUrl = bstrBaseUrl;
							}
						}
					}
				}
			}
			dcfTRACE( _T(" Selected:%s\n"), CString(bstrText).Left(200) );

			MtlCreateHrefUrlArray( arrUrl, CString(bstrText), CString(bstrLocationUrl) );
		}	//+++

		//DWORD dwOpenFlags = DonutGetStdOpenFlag();
		DWORD							dwOpenFlags = 0;

		for (int i = 0; i < arrUrl.GetSize(); ++i) {
			CString str(arrUrl[i]);
			DonutOpenFile(m_hWnd, arrUrl[i], dwOpenFlags);
		}
	}

};


void CChildFrame::OnEditOpenSelectedRef(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
{
	dcfTRACE( _T("CChildFrame::OnEditOpenSelectedRef\n") );
	m_MDITab.SetLinkState(LINKSTATE_B_ON);
	MtlForEachHTMLDocument2( m_spBrowser, _Function_OpenSelectedRef(m_hWnd, this) );
	m_MDITab.SetLinkState(LINKSTATE_OFF);
}


#if 1	//+++

void CChildFrame::OnEditOpenSelectedText(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
{
	dcfTRACE( _T("CChildFrame::OnEditOpenSelectedTitle\n") );
	CString strText = GetSelectedText();
	if (strText.IsEmpty())
		return;

	std::vector<CString> lines;
	lines.reserve(20);
	Misc::SeptTextToLines(lines, strText);
	size_t	size = lines.size();
  #if 1	//+++ I𕶎񒆂urlۂ̂ȂA񌟍ɂĂ݂.
	bool	f	= 0;
	for (unsigned i = 0; i < size; ++i) {
		CString& strUrl = lines[i];
		f |= (strUrl.Find(_T(':')) >= 0) || (strUrl.Find(_T('/')) >= 0) || (strUrl.Find(_T('.')) >= 0) ||  (strUrl.Find(_T('\\')) >= 0);
		if (f)
			break;
	}
	if (f == 0) {
		CDonutSearchBar*	pSearchBar = CDonutSearchBar::GetInstance();
		if (pSearchBar) {
			CEdit edit = pSearchBar->GetEditCtrl();
			edit.SendMessage(WM_CHAR, 'P');
			CString str		= lines[0];
			LPCTSTR		strExcept  = _T(" \t\"\r\n@");
			str.TrimLeft(strExcept);
			str.TrimRight(strExcept);
			edit.SetWindowText(str);
			pSearchBar->SearchWeb();
			return;
		}
	}
  #endif
	for (unsigned i = 0; i < size; ++i) {
		CString& strUrl = lines[i];
		Misc::StrToNormalUrl(strUrl);		//+++ ֐
		DonutOpenFile(m_hWnd, strUrl);
	}
}

#else

void CChildFrame::OnEditOpenSelectedText(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
{
	dcfTRACE( _T("CChildFrame::OnEditOpenSelectedTitle\n") );
	m_MDITab.SetLinkState(LINKSTATE_B_ON);
	MtlForEachHTMLDocument2( m_spBrowser, Mtl_bind_mem_fun_void(&CChildFrame::_OpenSelectedText, this) );
	m_MDITab.SetLinkState(LINKSTATE_OFF);
}


void CChildFrame::_OpenSelectedText(IHTMLDocument2 *pDocument)
{
	CString 	strText = _GetSelectedText(pDocument);
	if (strText.IsEmpty())
		return;
	std::vector<CString> lines;
	lines.reserve(20);
	SeptTextToLines(lines, strText);
	size_t size = lines.size();
	for (unsigned i = 0; i < size; ++i) {
		CString& strUrl = lines[i];
		StrToNormalUrl(strUrl);		//+++ ֐
		DonutOpenFile(m_hWnd, strUrl);
	}
}


CString CChildFrame::_GetSelectedText(IHTMLDocument2* pDocument)
{
	CComPtr<IHTMLSelectionObject>		spSelection;
	HRESULT 	hr	= pDocument->get_selection(&spSelection);
	if ( SUCCEEDED( hr ) ) {
	  #if 0
		CComBSTR	bstrType;
		hr	   = spSelection->get_type(&bstrType);
		if ( SUCCEEDED( hr ) ) {
		}
	  #endif
		CComPtr<IDispatch>				spDisp;
		hr	   = spSelection->createRange(&spDisp);
		if ( SUCCEEDED( hr ) ) {
			CComQIPtr<IHTMLTxtRange>	spTxtRange = spDisp;
			if (spTxtRange) {
				CComBSTR				bstrText;
				hr	   = spTxtRange->get_text(&bstrText);
				if (SUCCEEDED(hr) && !!bstrText)
					return	CString(bstrText);
			}
		}
	  #if 1	//+++ ENbNj[̎ANĂꍇ.
		CCustomContextMenu* pMenu = CCustomContextMenu::GetInstance();
		if (pMenu) {
			if (pMenu->GetContextMenuMode() == CONTEXT_MENU_ANCHOR) {
			  #if 1
				if (pMenu->GetAnchorUrl().IsEmpty() == 0) {
					return pMenu->GetAnchorUrl();
				}
			  #else
				const POINT&	rPt = pMenu->Point();
				CComPtr<IHTMLElement>		spElement;
				HRESULT 	hr	= pDocument->elementFromPoint(rPt.x, rPt.y, &spElement);
				CComBSTR	bstrName;
				spElement->get_tagName(&bstrName);
				spElement;
			  #endif
			}
		}
	  #endif
	}

	return CString();
}
#endif




// ===========================================================================
// 

//public:
void CChildFrame::searchEngines(const CString &strKeyWord )
{
	CString 	strSearchWord = strKeyWord;

	if (m_AddressBar.GetAddressBarExtendedStyle() & ABR_EX_SEARCH_REPLACE)
		strSearchWord.Replace( _T("@"), _T(" ") );

	//_ReplaceCRLF(strSearchWord,CString(_T(" ")));
	//strSearchWord.Replace('\n',' ');
	//strSearchWord.Remove('\r');
	strSearchWord.Replace( _T("\r\n"), _T("") );

	CIniFileI	pr( g_szIniFileName, STR_ADDRESS_BAR );
	CString 		strEngin = pr.GetStringUW( _T("EnterCtrlEngin"), NULL, 256 );
	pr.Close();
	::SendMessage(GetTopLevelParent(), WM_SEARCH_WEB_SELTEXT, (WPARAM) (LPCTSTR) strSearchWord, (LPARAM) (LPCTSTR) strEngin);

	//CWebBrowserCommandHandler<CChildFrame>::searchEngines(strSearchWord);
}


#if 0
//private:
CString CChildFrame::_ReplaceCRLF(CString &str, CString &strRep)
{
	CString strRet;
	TCHAR	ch;
	int 	len = str.GetLength();
	for (int i = 0; i < len; i++) {
		ch = str.GetAt(i);

		if ( (ch & 0xFF) == 0xa ) {
			strRet += strRep;
		} else if ( (ch & 0xFF) == 0xd ) {

		} else {
			strRet += ch;
		}
	}

	return strRep;
}
#endif



//
// y[W
//
LRESULT CChildFrame::OnFindKeyWord(LPCTSTR lpszKeyWord, BOOL bFindDown)
{
	// ANeBuEBhE̎擾
	HWND	hWndActive = MDIGetActive();
	if (hWndActive == NULL)
		return 0;

	if (!m_spBrowser)
		return 0;

	// hLg̎擾
	CComPtr<IDispatch>	spDisp;
	HRESULT 			hr	= m_spBrowser->get_Document(&spDisp);
	if ( FAILED(hr) )
		return 0;

	// html̎擾
	CComQIPtr<IHTMLDocument2>	spDocument = spDisp;
	if (!spDocument)
		return 0;

	// 
	BOOL	bSts = _FindKeyWordOne(spDocument, lpszKeyWord, bFindDown);
	if (bSts)
		return 1;

	// t[EBhE̎擾
	CComPtr<IHTMLFramesCollection2> 	spFrames;
	hr = spDocument->get_frames(&spFrames);
	// cf. Even if no frame, get_frames would succeed.
	if ( FAILED(hr) )
		return 0;

	// t[EBhE̐擾
	LONG	nCount	   = 0;
	hr = spFrames->get_length(&nCount);
	if ( FAILED(hr) )
		return 0;

	BOOL	bFindIt    = FALSE;
	if (bFindDown) {	// y[W - 
		for (LONG ii = m_nPainBookmark; ii < nCount; ii++) {
			CComVariant 			varItem(ii);
			CComVariant 			varResult;

			// t[̃EBhE擾
			hr		= spFrames->item(&varItem, &varResult);
			if ( FAILED(hr) )
				continue;

			CComQIPtr<IHTMLWindow2> spWindow = varResult.pdispVal;
			if (!spWindow)
				continue;

			CComPtr<IHTMLDocument2> spDocumentFr;
			hr		= spWindow->get_document(&spDocumentFr);
			if ( FAILED(hr) )
				continue;

			// 
			bFindIt = _FindKeyWordOne(spDocumentFr, lpszKeyWord, bFindDown);
			if (bFindIt) {
				m_nPainBookmark = ii;
				break;
			}
		}

		if (!bFindIt) {
			m_nPainBookmark = 0;
			m_strBookmark	= NULL;
		}

	} else {			// y[W - 
		if (m_nPainBookmark == 0 && m_strBookmark == NULL)
			m_nPainBookmark = nCount - 1;

		for (LONG ii = m_nPainBookmark; ii >= 0; ii--) {
			CComVariant 			varItem(ii);
			CComVariant 			varResult;

			// EBhE̎擾
			hr		= spFrames->item(&varItem, &varResult);
			if ( FAILED(hr) )
				continue;

			CComQIPtr<IHTMLWindow2> spWindow = varResult.pdispVal;
			if (!spWindow)
				continue;

			CComPtr<IHTMLDocument2> spDocumentFr;
			hr		= spWindow->get_document(&spDocumentFr);
			if ( FAILED(hr) )
				continue;

			// 
			bFindIt = _FindKeyWordOne(spDocumentFr, lpszKeyWord, bFindDown);
			if (bFindIt) {
				m_nPainBookmark = ii;
				break;
			}
		}

		if (!bFindIt) {
			m_nPainBookmark = 0;
			m_strBookmark	= NULL;
		}
	}

	return 1;
}


//
//y[W
//
BOOL CChildFrame::_FindKeyWordOne(IHTMLDocument2 *pDocument, const CString& rStrKeyWord, BOOL bFindDown)
{
	// hLgNULLȂI
	if (!pDocument)
		return FALSE;

	// ҋ@̓J[\vɕύX
	HCURSOR 	hCursor = SetCursor( LoadCursor(NULL, IDC_WAIT) );

	// L[[h擾
	//x strKeyWord = strtok( (LPSTR) strKeyWord.GetBuffer(0), " " );
	CString 	strKeyWord = Misc::GetStrWord( rStrKeyWord );
	LPCTSTR		strExcept  = _T(" \t\"\r\n@");
	strKeyWord.TrimLeft(strExcept);
	strKeyWord.TrimRight(strExcept);

	// <body>擾
	CComPtr<IHTMLElement>		spHTMLElement;
	pDocument->get_body(&spHTMLElement);
	if (!spHTMLElement)
		return FALSE;

  #if (defined _WIN64 == 0) 	//+++ bΏ.
	if (_CheckOsVersion_XPLater()) {
		;
	} else {
		//* +++ Vista64, Xp64 ɂẴ[`ƁAy[W2ڈȍ~̌
		//* 	ȂȂ悤?.. win2k@ok.
		//* 	Rg炷Win2kAƂāAƂ肠AXpȍ~͂̏
		//* 	ȂAɂĂ݂B Xp32 ͂ƂŊmF.
		// IE6(win2000?)gpAfindTextŃt[Y錻ۂR[h
		CComBSTR					bstr;
		spHTMLElement->get_innerHTML(&bstr);
		spHTMLElement->put_innerHTML(bstr);
	}
  #endif

	CComQIPtr<IHTMLBodyElement> spHTMLBody = spHTMLElement;
	if (!spHTMLBody)
		return FALSE;

	// eLXgW擾
	CComPtr<IHTMLTxtRange>		spTxtRange;
	spHTMLBody->createTextRange(&spTxtRange);

	if (!spTxtRange)
		return FALSE;

	if (m_strBookmark != NULL) {
		VARIANT_BOOL vMoveBookmark = VARIANT_FALSE;
		long		 nMove;
		spTxtRange->moveToBookmark(m_strBookmark, &vMoveBookmark);

		if (vMoveBookmark == VARIANT_FALSE) {
			;
		} else {
			if (bFindDown) {
				CComBSTR	bstrNow;
				spTxtRange->get_text(&bstrNow);

				CString  strNow(bstrNow);

				if (strNow != strKeyWord)
					spTxtRange->collapse(false);

				spTxtRange->moveStart( (BSTR) CComBSTR("Character"), 1, &nMove );
				spTxtRange->moveEnd  ( (BSTR) CComBSTR("Textedit" ), 1, &nMove );
			} else {
				spTxtRange->moveStart( (BSTR) CComBSTR("Textedit" ), -2, &nMove );
				spTxtRange->moveEnd  ( (BSTR) CComBSTR("Character"), -2, &nMove );
			}
		}
	}

	CComBSTR		bstrText(strKeyWord);
	BOOL			bSts  = FALSE;
	VARIANT_BOOL	vBool = VARIANT_FALSE;
	HRESULT 		hr	  = spTxtRange->findText(bstrText, (bFindDown) ? 1 : -1, 0, &vBool);

	if (FAILED(hr) || vBool == VARIANT_FALSE) {
		CComPtr<IHTMLSelectionObject> spSelection;
		HRESULT 	hr = pDocument->get_selection(&spSelection);

		if (spSelection)
			spSelection->empty();
	} else {
		if (spTxtRange->getBookmark(&m_strBookmark) != S_OK)
			m_strBookmark = NULL;

		spTxtRange->select();
		spTxtRange->scrollIntoView(VARIANT_TRUE);

		bSts = TRUE;

		DWORD		dwStatus = 0;
		CIniFileI pr( g_szIniFileName, _T("SEARCH") );
		pr.QueryValue( dwStatus, _T("Status") );
		pr.Close();

		if (dwStatus & STS_SCROLLCENTER)
			ScrollBy(pDocument);
	}

	// J[\ɖ߂
	SetCursor(hCursor);

	return bSts;
}
//^^^



void CChildFrame::ScrollBy(IHTMLDocument2 *pDoc2)
{
	CComPtr<IHTMLDocument3> 	   pDoc3;
	HRESULT 	hr = pDoc2->QueryInterface(&pDoc3);
	if ( FAILED(hr) )
		return;

	CComPtr<IHTMLElement>		   pElem;
	hr	= pDoc3->get_documentElement(&pElem);
	if ( FAILED(hr) )
		return;

	long		height = 0;
	hr	= pElem->get_offsetHeight(&height); 	// HTML\̈̍
	if ( FAILED(hr) )
		return;

	CComPtr<IHTMLSelectionObject>  pSel;
	hr	= pDoc2->get_selection(&pSel);
	if ( FAILED(hr) )
		return;

	CComPtr<IDispatch>			   pDisp;
	hr	= pSel->createRange(&pDisp);

	if ( FAILED(hr) )
		return;

	CComPtr<IHTMLTextRangeMetrics> pTxtRM;
	hr	= pDisp->QueryInterface(&pTxtRM);
	if ( FAILED(hr) )
		return;

	long		y = 0;
	hr	= pTxtRM->get_offsetTop(&y);		// I𕔕̉ʏォyW
	if ( FAILED(hr) )
		return;

	long scy = y - height / 2;				// ʒ܂ł̋

	// \1/4傫΃XN[
	if ( (scy > height / 4) || (scy < -height / 4) ) {
		CComPtr<IHTMLWindow2> pWnd;
		hr = pDoc2->get_parentWindow(&pWnd);

		if ( FAILED(hr) )
			return;

		pWnd->scrollBy(0, scy);
	}
}



#if 1 //def USE_UNDONUT_G_SRC		//+++ gaeunDonut_g ̏𔽉fĂ݂ꍇ.
// gae _Function_Hilightƈ̈ӖႤ̂Œ
struct CChildFrame::_Function_Hilight2 {
	LPCTSTR 	m_lpszKeyWord;
	BOOL		m_bHilight;

	_Function_Hilight2(LPCTSTR lpszKeyWord, BOOL bHilight)
		: m_lpszKeyWord(lpszKeyWord), m_bHilight(bHilight)
	{
	}

	void operator ()(IHTMLDocument2* pDocument)
	{
		if (m_bHilight) {
			if ( !FindHilight(pDocument) ) {
				MakeHilight(pDocument);
			}
		} else {
			RemoveHilight(pDocument);
		}
	}


	void MakeHilight(IHTMLDocument2* pDocument)
	{
		// // ҋ@̓J[\vɕύX
		// HCURSOR hCursor 	= SetCursor( LoadCursor(NULL, IDC_WAIT) );

		// L[[h̍ŏ̈擾
		CString		strKeyWord(m_lpszKeyWord);

		//+++ P؂𒲐
		LPCTSTR		strExcept	= _T(" \t\"\r\n@");
		strKeyWord = _tcstok( (LPTSTR) strKeyWord.GetBuffer(0), LPCTSTR(strExcept) );
		strKeyWord.TrimLeft(strExcept);
		strKeyWord.TrimRight(strExcept);

		int 	nLightIndex = 0;
		HRESULT hr;

		// L[[hɂȂ܂ŌJԂ
		while ( !strKeyWord.IsEmpty() ) {
			CComPtr<IHTMLElement>		spHTMLElement;
			CComPtr<IHTMLBodyElement>	spHTMLBody;
			// <body>擾
			hr = pDocument->get_body(&spHTMLElement);

			if (FAILED(hr) || spHTMLElement == NULL)
				break;

			//+++ "޸޸"̂悤?AAp̏ꍇŋHɁA
			//	  findtextŖtrueԂԂ悤(޸޸޸޸ł͑v悭킩Ȃ)
			//	  ŁAIE6(win2000?)gpfindTextŃt[Y錻ۂ邽߂̃R[h𗬗pđ΍.
			if (strKeyWord.Find(_T('')) || strKeyWord.Find(_T('')) || _CheckOsVersion_XPLater() == 0) {
				CComBSTR					bstr;
				spHTMLElement->get_innerHTML(&bstr);
				spHTMLElement->put_innerHTML(bstr);
			}

			spHTMLElement->QueryInterface(IID_IHTMLBodyElement, (void**) &spHTMLBody);
			if (spHTMLBody == NULL)
				break;

			// eLXgW擾
			CComPtr<IHTMLTxtRange>	  spHTMLTxtRange;
			spHTMLBody->createTextRange(&spHTMLTxtRange);

			// L[[h
			CComBSTR		bstrText(strKeyWord);
			VARIANT_BOOL	vBool	= VARIANT_FALSE;
			hr						= spHTMLTxtRange->findText(bstrText, 1, 0, &vBool);
			unsigned num = 0;									//+++ [vԂI邽߁A[vJEg
			//++++ while (vBool == VARIANT_TRUE)
			while (FAILED(hr) || vBool == VARIANT_TRUE)	//+++ _Function_Hilight̏ɂ킹Ă݂
			// while (SUCCEEDED(hr) && vBool == VARIANT_TRUE)
			{
				// ݑIĂHTMLeLXg擾
				CComBSTR			  bstrTextNow;
				spHTMLTxtRange->get_text(&bstrTextNow);

				// <span>t
				CComBSTR			  bstrTextNew;
				bstrTextNew.Append(g_lpszLight[nLightIndex]);
				bstrTextNew.Append(bstrTextNow);
				bstrTextNew.Append( _T("</span>") );

				// e^O"TEXTAREA"ȂÏ̍Ōֈړ(?)
				CComPtr<IHTMLElement> spParentElement;
				spHTMLTxtRange->parentElement(&spParentElement);
				CComBSTR			  bstrParentTag;
				spParentElement->get_tagName(&bstrParentTag);

				if (bstrParentTag == _T("TEXTAREA"))
					spHTMLTxtRange->collapse(VARIANT_FALSE);

				spHTMLTxtRange->pasteHTML(bstrTextNew);
				if (++num > 10000)								//+++ ʏ̃y[WŃnCCguȂɂ邱Ƃ͂Ȃ낤ŁA[vłǂ߂Ƃ
					break;
				vBool = VARIANT_FALSE;
				hr	  = spHTMLTxtRange->findText(bstrText, 1, 0, &vBool);
			}

			nLightIndex++;

			if (nLightIndex >= g_LIGHTMAX)
				nLightIndex = 0;

			//CString 	strText(bstrText);
			//CString	strTextNew(bstrText);
			strKeyWord = _tcstok(NULL, LPCTSTR(strExcept) );
			strKeyWord.TrimLeft(strExcept);
			strKeyWord.TrimRight(strExcept);
		}

		// // J[\ɖ߂
		// SetCursor(hCursor);
	}


	void RemoveHilight(IHTMLDocument2* pDocument)
	{
		CComBSTR	hilightID(L"unDonutHilight");
		CComBSTR	hilightTag(L"SPAN");

		CComPtr<IHTMLElementCollection> pAll;

		if (SUCCEEDED( pDocument->get_all(&pAll) ) && pAll != NULL) {
			CComVariant 		id(L"unDonutHilight");
			CComPtr<IDispatch>	pDisp;
			CComVariant 		vIndex(0);
			pAll->item(id, vIndex, &pDisp);

			if (pDisp == NULL) {
				return;
			}

			CComPtr<IUnknown>	pUnk;

			if (SUCCEEDED( pAll->get__newEnum(&pUnk) ) && pUnk != NULL) {
				CComQIPtr<IEnumVARIANT> pEnumVariant = pUnk;

				if (pEnumVariant != NULL) {
					VARIANT  v;
					ULONG	 ul;
					CComBSTR bstrTagName;
					CComBSTR bstrID;
					CComBSTR bstrTmp;

					while (pEnumVariant->Next(1, &v, &ul) == S_OK) {
						CComQIPtr<IHTMLElement> pElement = v.pdispVal;
						VariantClear(&v);

						if (pElement != NULL) {
							bstrTagName.Empty();
							bstrID.Empty();
							pElement->get_tagName(&bstrTagName);
							pElement->get_id(&bstrID);

							if (bstrTagName == hilightTag && bstrID == hilightID) {
								bstrTmp.Empty();
								pElement->get_innerHTML(&bstrTmp);
								pElement->put_outerHTML(bstrTmp);
							}
						}
					}
				}
			}
		}
	}

	// nCCgłɂĂ邩mF
	BOOL FindHilight(IHTMLDocument2* pDocument)
	{
		CComPtr<IHTMLElementCollection> 	pAll;

		if (SUCCEEDED(pDocument->get_all(&pAll)) && pAll != NULL) {
			CComVariant 		id(L"unDonutHilight");
			CComPtr<IDispatch>	pDisp;
			CComVariant 		vIndex(0);
			pAll->item(id, vIndex, &pDisp);
			if (pDisp != NULL) {
				return TRUE;
			}
		}
		return FALSE;
	}
};
#endif	// KIKE_UNDONUT_G





struct CChildFrame::_Function_SelectEmpt {
	_Function_SelectEmpt(){ }

	void operator ()(IHTMLDocument2 *pDocument)
	{
		CComPtr<IHTMLSelectionObject> spSelection;
		HRESULT 	hr = pDocument->get_selection(&spSelection);
		if (spSelection)
			spSelection->empty();
	}
};



#if 0	//+++ _Function_Hilight2 ɒu...
struct CChildFrame::_Function_Hilight {
private:
	LPCTSTR 	m_lpszKeyWord;
	BOOL		m_bNowHilight_;

public:
	_Function_Hilight(LPCTSTR lpszKeyWord, BOOL bNowHilight)
		: m_lpszKeyWord(lpszKeyWord), m_bNowHilight_(bNowHilight)
	{
	}

	void operator ()(IHTMLDocument2 *pDocument)
	{
		if (m_bNowHilight_ == FALSE)
			MakeHilight(pDocument);
		else
			RemoveHilight(pDocument);
	}


	void MakeHilight(IHTMLDocument2 *pDocument)
	{
		// ҋ@̓J[\vɕύX
		HCURSOR hCursor 	= SetCursor( LoadCursor(NULL, IDC_WAIT) );

		// L[[h̍ŏ̈擾
		CString strKeyWord(m_lpszKeyWord);

		LPCTSTR		strExcept	= _T(" \t\"\r\n@");
		strKeyWord = _tcstok( (LPTSTR) strKeyWord.GetBuffer(0), LPCTSTR(strExcept) );
		strKeyWord.TrimLeft(strExcept);
		strKeyWord.TrimRight(strExcept);

		int 	nLightIndex = 0;
		HRESULT hr;

		// L[[hɂȂ܂ŌJԂ
		while ( !strKeyWord.IsEmpty() ) {
			// <body>擾
			CComPtr<IHTMLElement>		spHTMLElement;
			hr = pDocument->get_body(&spHTMLElement);

			if (FAILED(hr) || spHTMLElement == NULL)
				break;

		  #if (defined _WIN64 == 0) 	//+++ y[WƏ킹Ă...
			if (_CheckOsVersion_XPLater()) {
				;
			} else {
				// IE6(win2000?)gpAfindTextŃt[Y錻ۂ邽߂̃R[h
				CComBSTR					bstr;
				spHTMLElement->get_innerHTML(&bstr);
				spHTMLElement->put_innerHTML(bstr);
			}
		  #endif

			CComQIPtr<IHTMLBodyElement> spHTMLBody = spHTMLElement;
			if (spHTMLBody == NULL)
				break;

			// eLXgW擾
			CComPtr<IHTMLTxtRange>		spHTMLTxtRange;
			spHTMLBody->createTextRange(&spHTMLTxtRange);

			// L[[h
			CComBSTR					bstrText(strKeyWord);
			VARIANT_BOOL				vBool	   = VARIANT_FALSE;
			HRESULT 					hr		   = spHTMLTxtRange->findText(bstrText, 1, 0, &vBool);
			//HRESULT hr = _FindText(spHTMLTxtRange, bstrText, 1, 0, vBool);

			// findTextɐĂJԂ
			while (FAILED(hr) || vBool == VARIANT_TRUE) {
				// ݑIĂHTMLeLXg擾
				CComBSTR			  bstrTextNow;
				//spHTMLTxtRange->get_text(&bstrTextNow);
				spHTMLTxtRange->get_htmlText(&bstrTextNow);

				// <span>t
				CComBSTR			  bstrTextNew;
				bstrTextNew.Append(g_lpszLight[nLightIndex]);
				bstrTextNew.Append(bstrTextNow);
				bstrTextNew.Append( _T("</span>") );

				// e^O"TEXTAREA"ȂÏ̍Ōֈړ(?)
				CComPtr<IHTMLElement> spParentElement;
				CComBSTR			  bstrParentTag;
				spHTMLTxtRange->parentElement(&spParentElement);
				spParentElement->get_tagName(&bstrParentTag);

				if (bstrParentTag == "TEXTAREA")
					spHTMLTxtRange->collapse(VARIANT_FALSE);

				spHTMLTxtRange->pasteHTML(bstrTextNew);
				hr = spHTMLTxtRange->findText(bstrText, 1, 0, &vBool);
			}

			// nCCgFύX
			nLightIndex++;

			if (nLightIndex >= g_LIGHTMAX)
				nLightIndex = 0;

			// ̈擾
			CString 					strText(bstrText), strTextNew(bstrText);
			strKeyWord = _tcstok(NULL, LPCTSTR(strExcept));
			strKeyWord.TrimLeft(strExcept);
			strKeyWord.TrimRight(strExcept);
		}

		// J[\ɖ߂
		SetCursor(hCursor);
	}


	void RemoveHilight(IHTMLDocument2 *pDocument)
	{
		//+++ 	donutR13TESTł testid(7,"DonutP") ƂȂĂ.
	  #if 0 //def USE_ORG_UNDONUT_INI	//+++
		CComBSTR				testid (7, "DonutP");
	  #else
		CComBSTR				testid (6, "Donut");
	  #endif
		CComBSTR				testtag(5, "SPAN" );
		CComPtr<IHTMLElementCollection> 	spAllElements;
		pDocument->get_all(&spAllElements);
		CComPtr<IUnknown>		lpUnk;
		CComPtr<IEnumVARIANT>	lpNewEnum;

		if (SUCCEEDED( spAllElements->get__newEnum(&lpUnk) ) && lpUnk != NULL) {
			lpUnk->QueryInterface(IID_IEnumVARIANT, (void **) &lpNewEnum);
			CComVariant varElement;

			while (lpNewEnum->Next(1, &varElement, NULL) == S_OK) {
				CComQIPtr<IHTMLElement> spElement = varElement.pdispVal;

				if (spElement) {
					CComBSTR	id;
					CComBSTR	tag;
					spElement->get_id(&id);
					spElement->get_tagName(&tag);
					if ( (id == testid) && (tag == testtag) ) {
						BSTR innerText;
						spElement->get_innerHTML(&innerText);
						spElement->put_outerHTML(innerText);
					}
				}
				varElement.Clear();
			}
		}
	}

};
#endif



//+++
void CChildFrame::SetSearchWordAutoHilight( const CString& str, bool autoHilightSw )
{
	m_strSearchWord = str;
	m_bAutoHilight	= autoHilightSw ;
}



//vvv
// UH
LRESULT CChildFrame::OnHilight(LPCTSTR lpszKeyWord)	//+++ gpȈ폜. , BOOL bToggle /*= TRUE*/, BOOL bFlag /*= FALSE*/)
{
	HWND hWndActive = MDIGetActive();
	if (hWndActive == NULL)
		return 0;

  #if 0	//+++ gp̎dg݂폜
	if (!bToggle)
		m_bNowHilight = bFlag;
  #endif
  #if 1	//+++
	bool bHilightSw = CDonutSearchBar::GetInstance()->GetHilightSw();
	//if (m_bNowHilight != bHilightSw)
	{
		//MtlForEachHTMLDocument2( m_spBrowser, _Function_SelectEmpt() );
		//MtlForEachHTMLDocument2( m_spBrowser, _Function_Hilight(lpszKeyWord, m_bNowHilight) );
		m_bNowHilight	= bHilightSw;
		if (bHilightSw)
			m_strSearchWord = lpszKeyWord;
		else
			m_strSearchWord.Empty();

		MtlForEachHTMLDocument2g(m_spBrowser, _Function_SelectEmpt());
		MtlForEachHTMLDocument2g(m_spBrowser, _Function_Hilight2(lpszKeyWord, bHilightSw));
	}
  #elif 1 //def USE_UNDONUT_G_SRC		//+++ gaeunDonut_g ̏𔽉fĂ݂ꍇ.
   #if 1	//+++
	m_bNowHilight = CDonutSearchBar::GetInstance()->GetHilightSw();
   #else
	m_bNowHilight = !m_bNowHilight;
   #endif
	if (m_bNowHilight)
		m_strSearchWord = lpszKeyWord;
	else
		m_strSearchWord.Empty();
	MtlForEachHTMLDocument2g(m_spBrowser, _Function_SelectEmpt());
	MtlForEachHTMLDocument2g(m_spBrowser, _Function_Hilight2(lpszKeyWord, m_bNowHilight));
  #else
	MtlForEachHTMLDocument2( m_spBrowser, _Function_SelectEmpt() );
	MtlForEachHTMLDocument2( m_spBrowser, _Function_Hilight(lpszKeyWord, m_bNowHilight) );
	+++ m_bNowHilight = !m_bNowHilight;
  #endif
	return 1;
}


#if 1 //def USE_UNDONUT_G_SRC		//+++ gaeunDonut_g ̏𔽉fĂ݂ꍇ.
LRESULT CChildFrame::OnHilightOnce(IDispatch *pDisp, LPCTSTR lpszKeyWord)
{
	CComQIPtr<IWebBrowser2> 	pWebBrowser = pDisp;
	if (pWebBrowser!=NULL) {
		if (SUCCEEDED(pWebBrowser->get_Document(&pDisp))) {
			CComQIPtr<IHTMLDocument2> pDoc = pDisp;
			if(pDoc) {
				_Function_SelectEmpt	se;
				se(pDoc);

				_Function_Hilight2		hl(lpszKeyWord, TRUE);
				hl(pDoc);
			}
		}
	}
	return 1;
}
#endif



#if 0	//+++
void CChildFrame::OnSearchWeb_engineId(UINT code, int id, HWND hWnd)
{
	ATLASSERT(ID_INSERTPOINT_SEARCHENGINE <= id && id <= ID_INSERTPOINT_SEARCHENGINE_END);
	MtlSendCommand(CDonutSearchBar::GetInstance()->m_hWnd, WORD(id));
}
#endif

