/**
 *	@file	UrlSecurityOption.h
 *	@brief	donut̃IvV : URLʃZLeB.
 *	@note
 *		undonut+modŒǉ.
 */

#pragma once

#include "../resource.h"


class CUrlSecurityOption {
	friend class CUrlSecurityPropertyPage;

public:
	class COptUrl {
	public:
		COptUrl() : m_opts(0), m_flags(0) {}
		COptUrl(unsigned flags, unsigned opts, LPCTSTR pUrl) : m_flags(flags), m_opts(opts), m_url(pUrl) {;}

		operator LPCTSTR() const { return LPCTSTR(m_url); }		//+++ 蕶̂ӂ
		bool operator==(const COptUrl& rhs) const { return m_url == rhs.m_url; }
		bool operator==(LPCTSTR r) const { return m_url == r; }

	public:
		unsigned	m_flags;
		unsigned	m_opts;
		CString		m_url;
	};
	typedef std::list<COptUrl>		COptUrlList;

	static bool 					s_bValid;		//+++ ref by CMainFrame

	static void GetProfile();
	static void WriteProfile();
	//static bool SearchString(const CString &strURL);
	static bool FindUrl(const CString &strURL, DWORD* exprop, DWORD* flags = 0);
	static void Add(unsigned flags, unsigned opts, const CString &strURL);

	static bool activePageToo() { return s_bActivePageToo; }

private:
	static COptUrlList				s_urlSecurity;
	static bool						s_bActivePageToo;

	static COptUrlList::iterator	get_optUrlList_iterator(unsigned no);
};


class CUrlSecurityPropertyPage
	: public CPropertyPageImpl<CUrlSecurityPropertyPage>
	, public CWinDataExchange<CUrlSecurityPropertyPage>
{
public:
	// Declarations
	enum { IDD = IDD_PROPPAGE_URLSECURITY };

private:
	// Data members
	CString 						m_strAddressBar;
	CListBox						m_listbox;
	CEdit							m_edit;
	int 							m_nValid;
	int 							m_nActPag;
	CContainedWindow				m_wndList;

public:
	// Constructor
	CUrlSecurityPropertyPage(const CString &strAddressBar);

	// DDX map
	BEGIN_DDX_MAP( CUrlSecurityPropertyPage )
		DDX_CHECK( IDC_IGNORED_URL_VALID	, m_nValid  )
		DDX_CHECK( IDC_CHK_URLSEC_ACTPAG    , m_nActPag )
	END_DDX_MAP()

	// Overrides
	BOOL	OnSetActive();
	BOOL	OnKillActive();
	BOOL	OnApply();

	void	DebugPrint();

private:
	// overrides
	BOOL	_DoDataExchange(BOOL bSaveAndValidate); // get data from controls?

public:
	// Message map and handlers
	BEGIN_MSG_MAP( CUrlSecurityPropertyPage )
		MESSAGE_HANDLER( WM_INITDIALOG	, OnInitDialog )
		MESSAGE_HANDLER( WM_DESTROY 	, OnDestroy    )
		COMMAND_ID_HANDLER_EX( IDC_ADD_BUTTON		, OnAddCmd	  )
		COMMAND_ID_HANDLER_EX( IDC_DELALL_BUTTON	, OnDelAllCmd )
		COMMAND_ID_HANDLER_EX( IDC_DEL_BUTTON		, OnDelCmd	  )
		COMMAND_ID_HANDLER_EX( IDC_BTN_URLSEC_UP	, OnBtnUp	  )
		COMMAND_ID_HANDLER_EX( IDC_BTN_URLSEC_DOWN	, OnBtnDown	  )
		COMMAND_ID_HANDLER_EX( IDC_BTN_URLSEC_SETTING,OnBtnSetting)
		COMMAND_HANDLER_EX( IDC_IGNORED_URL_LIST, LBN_SELCHANGE, OnSelChange )
		CHAIN_MSG_MAP( CPropertyPageImpl<CUrlSecurityPropertyPage> )
	ALT_MSG_MAP(1)
		MSG_WM_KEYUP( OnListKeyUp )
	END_MSG_MAP()

	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL &bHandled);
	LRESULT OnDestroy(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL &bHandled);

private:
	void	OnDelCmd(UINT wNotifyCode, int wID, HWND hWndCtl);
	void	OnDelAllCmd(UINT wNotifyCode, int wID, HWND hWndCtl);
	void	OnAddCmd(UINT wNotifyCode, int wID, HWND hWndCtl);
	void	OnSelChange(UINT code, int id, HWND hWnd);
	void	OnListKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	void	OnBtnUp(UINT wNotifyCode, int wID, HWND hWndCtl);
	void	OnBtnDown(UINT wNotifyCode, int wID, HWND hWndCtl);
	void	OnBtnSetting(UINT wNotifyCode, int wID, HWND hWndCtl);
	void 	DispExOpts();
	void 	DispExOptsFlag(unsigned exopts, unsigned flags);

	struct _AddToListBox : public std::unary_function<const CUrlSecurityOption::COptUrl &, void> {
		CListBox &_box;
		_AddToListBox(CListBox &box) : _box(box) { }
		result_type operator ()(argument_type src)
		{
			_box.AddString(src.m_url);
		}
	};

	void _GetData();
};
